/**************************************************************************
//0 POS: 0 to 599 (40*15)
//1 POS: 0 to 139 (20*07)
//2 POS: 0 to 064 (13*05)
 **************************************************************************/
#include "includes.h"
#include "System/system.h"
#include "LCD/font.h"

void cTxos::vLCDSendData(unsigned short usAddr, unsigned short usData)
{
	FIO0PIN_bit.P0_19=0;//CS#
	FIO0DIR0 = 0xff;//0:7
	FIO2DIR0 = 0xff;//8:15
	
	if(ucSystemPowerMode == 0x03)
	{
		//---register O
		FIO1PIN_bit.P1_19=0;//RS	0-->register address	1-->register data
		FIO0PIN0 = usAddr;//0:7
		FIO2PIN0 = (usAddr >> 8);//8:15
		//clock
		vDelayUS(LCDCLOCKDELAYUS);
		FIO1PIN_bit.P1_20=0;//WR#
		
		vDelayUS(LCDCLOCKDELAYUS);
		FIO1PIN_bit.P1_20=1;//WR#
		
		//**************************
		//---data O
		FIO1PIN_bit.P1_19=1;//RS	0-->register address	1-->register data
		FIO0PIN0 = usData;//0:7
		FIO2PIN0 = (usData >> 8);//8:15
		//clock
		vDelayUS(LCDCLOCKDELAYUS);
		FIO1PIN_bit.P1_20=0;//WR#
		
		vDelayUS(LCDCLOCKDELAYUS);
	}
	else
	{
		//---register O
		FIO1PIN_bit.P1_19=0;//RS	0-->register address	1-->register data
		FIO0PIN0 = usAddr;//0:7
		FIO2PIN0 = (usAddr >> 8);//8:15
		
		//clock
		asm("NOP");
		FIO1PIN_bit.P1_20=0;//WR#
		asm("NOP");
		FIO1PIN_bit.P1_20=1;//WR#
		
		//**************************
		//---data O
		FIO1PIN_bit.P1_19=1;//RS	0-->register address	1-->register data
		FIO0PIN0 = usData;//0:7
		FIO2PIN0 = (usData >> 8);//8:15
		
		//clock
		asm("NOP");
		FIO1PIN_bit.P1_20=0;//WR#
		asm("NOP");
	}
	FIO1PIN_bit.P1_20=1;//WR#
	FIO0PIN_bit.P0_19=1;//CS#
}

unsigned short cTxos::usLCDReceiveData(unsigned short usAddr)
{
	FIO0PIN_bit.P0_19=0;//CS#

	//************************
	//---register O
	FIO1PIN_bit.P1_19=0;//RS			0-->register address	1-->register data
	FIO0DIR0 = 0xff;//0:7
	FIO2DIR0 = 0xff;//8:15
	FIO0PIN0 = usAddr;//0:7
	FIO2PIN0 = (usAddr >> 8);//8:15
	//clock
	vDelayUS(LCDCLOCKDELAYUS);
	FIO1PIN_bit.P1_20=0;//WR#
	
	vDelayUS(LCDCLOCKDELAYUS);
	FIO1PIN_bit.P1_20=1;//WR#
	
	//************************
	//---data I
	FIO1PIN_bit.P1_19=1;//RS			0-->register address	1-->register data
	FIO0DIR0 = 0x00;//0:7
	FIO2DIR0 = 0x00;//8:15
	//clock
	FIO1PIN_bit.P1_21=0;//RD#
	vDelayUS(100);
	
	usAddr	= FIO0PIN0;		 //0:7
	usAddr |= FIO2PIN0 << 8;//8:15
	
	FIO1PIN_bit.P1_21=1;//RD#
	vDelayUS(100);

	FIO0PIN_bit.P0_19=1;//CS#
	
	return usAddr;
}

void cTxos::vLCDInit()
{
	vDelayUS(100000);
	FIO1PIN_bit.P1_22=0;//RESET#
	FIO0PIN_bit.P0_19=1;//CS#
	FIO1PIN_bit.P1_19=1;//RS			0-->register address	1-->register data
	FIO1PIN_bit.P1_20=1;//WR#
	FIO1PIN_bit.P1_21=1;//RD#
	vDelayUS(100000);
	FIO1PIN_bit.P1_22=1;//RESET#
	vDelayUS(500000);
	
	vLCDSendData(0x00E3,						0x3008);
	vLCDSendData(0x00E7,						0x0012);
	vLCDSendData(0x00Ef,						0x1231);
	vLCDSendData(LCD_INS_START_OSC,				0x0100);
	vDelayUS(50000);
	vLCDSendData(LCD_INS_DRIV_OUT_CTRL,			0x0100);//0x0000
	vLCDSendData(LCD_INS_DRIV_WAV_CTRL,			0x0700);
	vLCDSendData(LCD_INS_ENTRY_MOD,				0x1030);
	vLCDSendData(LCD_INS_RESIZE_CTRL,			0x0000);
	vLCDSendData(LCD_INS_DISP_CTRL2,			0x0207);
	vLCDSendData(LCD_INS_DISP_CTRL3,			0x0000);
	vLCDSendData(LCD_INS_DISP_CTRL4,			0x0000);
	vLCDSendData(LCD_INS_RGB_DISP_IF_CTRL1,		0x0000);
	vLCDSendData(LCD_INS_FRM_MARKER_POS,		0x0000);
	vLCDSendData(LCD_INS_RGB_DISP_IF_CTRL2,		0x0000);
	//on
	vLCDSendData(LCD_INS_POW_CTRL1,				0x0000);
	vLCDSendData(LCD_INS_POW_CTRL2,				0x0007);
	vLCDSendData(LCD_INS_POW_CTRL3,				0x0000);
	vLCDSendData(LCD_INS_POW_CTRL4,				0x0000);
	vDelayUS(200000);
	vLCDSendData(LCD_INS_POW_CTRL1,				0x1490);
	vLCDSendData(LCD_INS_POW_CTRL2,				0x0227);
	vDelayUS(50000);
	vLCDSendData(LCD_INS_POW_CTRL3,				0x001a);
	vDelayUS(50000);
	vLCDSendData(LCD_INS_POW_CTRL4,				0x1400);
	vLCDSendData(LCD_INS_POW_CTRL7,				0x0019);
	vLCDSendData(LCD_INS_FRM_RATE_COL_CTRL,		0x000c);
	vDelayUS(50000);
	vLCDSendData(LCD_INS_GRAM_HOR_AD,			0x0000);
	vLCDSendData(LCD_INS_GRAM_VER_AD,			0x0000);
	//GAMMA		
	vLCDSendData(LCD_INS_GAMMA_CTRL1,			0x0000);
	vLCDSendData(LCD_INS_GAMMA_CTRL2,			0x0607);
	vLCDSendData(LCD_INS_GAMMA_CTRL3,			0x0305);
	vLCDSendData(LCD_INS_GAMMA_CTRL4,			0x0000);
	vLCDSendData(LCD_INS_GAMMA_CTRL5,			0x1604);
	vLCDSendData(LCD_INS_GAMMA_CTRL6,			0x0204);
	vLCDSendData(LCD_INS_GAMMA_CTRL7,			0x0001);
	vLCDSendData(LCD_INS_GAMMA_CTRL8,			0x0707);
	vLCDSendData(LCD_INS_GAMMA_CTRL9,			0x0000);
	vLCDSendData(LCD_INS_GAMMA_CTRL10,			0x000f);
	//GRAM		
	vLCDSendData(LCD_INS_HOR_START_AD,			0x0000);
	vLCDSendData(LCD_INS_HOR_END_AD,			0x00ef);
	vLCDSendData(LCD_INS_VER_START_AD,			0x0000);
	vLCDSendData(LCD_INS_VER_END_AD,			0x013f);
	vLCDSendData(LCD_INS_GATE_SCAN_CTRL1,		0x2700);//a700
	vLCDSendData(LCD_INS_GATE_SCAN_CTRL2,		0x0001);
	vLCDSendData(LCD_INS_GATE_SCAN_CTRL3,		0x0000);
	//partial display
	vLCDSendData(LCD_INS_PART_IMG1_DISP_POS,	0x0000);
	vLCDSendData(LCD_INS_PART_IMG1_START_AD,	0x0000);
	vLCDSendData(LCD_INS_PART_IMG1_END_AD,		0x0000);
	vLCDSendData(LCD_INS_PART_IMG2_DISP_POS,	0x0000);
	vLCDSendData(LCD_INS_PART_IMG2_START_AD,	0x0000);
	vLCDSendData(LCD_INS_PART_IMG2_END_AD,		0x0000);
	//plan control
	vLCDSendData(LCD_INS_PANEL_IF_CTRL1,		0x0010);
	vLCDSendData(LCD_INS_PANEL_IF_CTRL2,		0x0600);
	vLCDSendData(LCD_INS_DISP_CTRL1,			0x0133);
	//clrscr
	vLCDClrScr();
	
	//Font init
	vSetPBGCS(0x0000, 0xffff, 0x0000, 1);
}

void cTxos::vLCDClrScr()
{
	vHighSpeedOperation();
	//set addres to 0
	vLCDSendData(LCD_INS_GRAM_HOR_AD,0x0000);
	vLCDSendData(LCD_INS_GRAM_VER_AD,0x0000);
	
	for(unsigned int uiI=0; uiI<(240*320); uiI++)
		vLCDSendData(LCD_INS_RW_GRAM,0xffff);
	
	//set addres to 0
	vLCDSendData(LCD_INS_GRAM_HOR_AD,0x0000);
	vLCDSendData(LCD_INS_GRAM_VER_AD,0x0000);
	vNormalOperation();
}

void cTxos::vPrintPixel(unsigned short usX,
				 		unsigned char	ucY,
				 		unsigned short usColor)
{
	vLCDSendData(LCD_INS_GRAM_VER_AD, usX);//320
	vLCDSendData(LCD_INS_GRAM_HOR_AD, ucY);//240
	vLCDSendData(LCD_INS_RW_GRAM, usColor);
}

void cTxos::vPrint(unsigned char ucChar)
{
	unsigned short usY, usX;
	unsigned char	ucI, ucJ, ucK, ucRe;
	
	ucLastChar = ucChar;
	
	if(ucFontSize == 1)
	{
		usX = ((usFontCharPos/40)*16);
		
		if(bRTL == 1)
			usY = 312-((usFontCharPos%40)*8);
		else
			usY = ((usFontCharPos%40)*8);
	}
	else if(ucFontSize == 2)
	{
		usX = ((usFontCharPos/20)*32);
		
		if(bRTL == 1)
			usY = 304-((usFontCharPos%20)*16);
		else
			usY = ((usFontCharPos%20)*16);
	}
	else
	{
		usX = ((usFontCharPos/13)*48);
		
		if(bRTL == 1)
			usY = 288-((usFontCharPos%13)*24);
		else
			usY = ((usFontCharPos%13)*24);
	}
	usFontCharPos++;
	
	for(ucI=0; ucI<(16*ucFontSize); ucI++)
	{
		vLCDSendData(LCD_INS_GRAM_HOR_AD, usX+ucI);//240

		for(ucJ=0x80, ucK=0; ucJ!=0x00; ucJ/=2, ucK+=ucFontSize)
		{
			if(succUTF8[ucChar-0x20][ucI/ucFontSize]&ucJ)
			{
				for(ucRe=0; ucRe<ucFontSize; ucRe++)
				{
					vLCDSendData(LCD_INS_GRAM_VER_AD, usY+ucK+ucRe);//320
					vLCDSendData(LCD_INS_RW_GRAM, usFontColor);
				}
			}
			else
			{
				for(ucRe=0; ucRe<ucFontSize; ucRe++)
				{
					vLCDSendData(LCD_INS_GRAM_VER_AD, usY+ucK+ucRe);//320
					vLCDSendData(LCD_INS_RW_GRAM, usFontBackground);
				}
			}
		}
	}
}

void cTxos::vPrint2(unsigned char	ucChar,
			 unsigned short usCharPos,
			 unsigned short usBackground,
			 unsigned short usColor,
			 unsigned char	ucSize)
{
	usFontCharPos		 = usCharPos;
	usFontBackground	 = usBackground;
	usFontColor			 = usColor;
	ucFontSize			 = ucSize;
	vPrint(ucChar);
}

void cTxos::vSPrint(char const* usString)
{
	char			ucPrintChar;
	unsigned short	usI;
	
	if(usString[0] > 0x80)
		bRTL = 1;
	else
		bRTL = 0;
	
	for(usI=0; ; usI++)
	{
		ucPrintChar = usString[usI];
		
		if(ucPrintChar =='\0')
			break;
		
		if(usFontCharPos > 599)
			usFontCharPos = 0;
		
		if(ucPrintChar == '\t')
		{
			vPrint(' ');
			vPrint(' ');
			vPrint(' ');
			vPrint(' ');
		}
		else if(ucPrintChar == '\r' || ucPrintChar == '\n')
			vPrintNewLine();
		else if(ucPrintChar == '\a')
			vBuzzMS(500,250,0x3ff);
		else if(ucPrintChar > 0x80)
		{
			if(ucPrintChar == 0xC7)//
			{
				if(usString[usI+1] == 0xE1)
				{
					if(usString[usI+2] == 0xE1)
					{
						if(usString[usI+3] == 0xE5)
						{
							vPrintALLAH();
							usI += 3;

							goto _VSPrint_Continiue;
						}
					}
				}
			}
			ucPrintChar = ucSystemUTFPersianConvert(usString[usI], usString[usI+1]);
			vPrint(ucPrintChar);
			
		  _VSPrint_Continiue:
			asm("NOP");
		}
		else
			vPrint(ucPrintChar);
	}
}

void cTxos::vSPrint2(char		const*	usString,
					 unsigned	short	usCharPos,
					 unsigned	short	usBackground,
					 unsigned	short	usColor,
					 unsigned	char	ucSize)
{
	usFontCharPos		 = usCharPos;
	usFontBackground	 = usBackground;
	usFontColor			 = usColor;
	ucFontSize			 = ucSize;
	
	vSPrint(usString);
}

void cTxos::vSetPBGCS(unsigned short usCharPos,
					  unsigned short usBackground,
					  unsigned short usColor,
					  unsigned char	ucSize)
{
	usFontCharPos		 = usCharPos;
	usFontBackground	 = usBackground;
	usFontColor			 = usColor;
	ucFontSize			 = ucSize;
}

void cTxos::vPrintNewLine()
{
	if(ucFontSize == 1)
	{
		usFontCharPos /= 40;
		usFontCharPos++;
		usFontCharPos *= 40;
	}
	else if(ucFontSize == 2)
	{
		usFontCharPos /= 20;
		usFontCharPos++;
		usFontCharPos *= 20;
	}
	else
	{
		usFontCharPos /= 13;
		usFontCharPos++;
		usFontCharPos *= 13;
	}
}

void cTxos::vDetailsLineClr(unsigned char ucLine) 
{
	//ucLine:0-19
	vSetPBGCS((ucLine*40), 0xffff, 0x0000, 1);
	vSPrint("                              ");
	vSetPBGCS((ucLine*40), 0xffff, 0x0000, 1);
}

unsigned char cTxos::ucSystemUTFPersianConvert(unsigned char ucChar, unsigned char ucNextChar)
{
	if(ucChar == 0xC2)
		return succConversion[0][0];
	else if(ucChar == 0xC4)
		return succConversion[30][0];
	else if(ucChar == 0xC3 || ucChar == 0xC5 || ucChar == 0xC7)
		return succConversion[0][1];
	else
	{
		if(ucNextChar > 0x80)
		{
			if(ucChar == 0xC6)//
				return succConversion[36][0];
			
			if(ucChar == 0xC8)//
				return succConversion[1][0];
			
			if(ucChar == 0xC9)//
				return succConversion[29][0];
			
			if(ucChar == 0x90)//
				return succConversion[32][0];
			
			if(ucChar == 0x8D)//
				return succConversion[33][0];
			
			if(ucChar == 0x81)//
				return succConversion[34][0];
			
			if(ucChar == 0x8E)//
				return succConversion[35][0];
			
			if(ucChar == 0x98)//
				return succConversion[23][0];
			
			ucChar -= 0xC8;
			
			return succConversion[ucChar][0];
		}
		else
		{
			if(ucChar == 0xC6)//
				return succConversion[36][1];
			
			if(ucChar == 0xC8)//
				return succConversion[1][1];
			
			if(ucChar == 0xC9)//
				return succConversion[29][1];
			
			if(ucChar == 0x90)//
				return succConversion[32][1];
			
			if(ucChar == 0x8D)//
				return succConversion[33][1];
			
			if(ucChar == 0x81)//
				return succConversion[34][1];
			
			if(ucChar == 0x8E)//
				return succConversion[35][1];
			
			if(ucChar == 0x98)//
				return succConversion[23][1];
			
			ucChar -= 0xC8;
			
			return succConversion[ucChar][1];
		}
	}
}

void cTxos::vPrintALLAH()
{
	unsigned short	usY, usX;
	unsigned char	ucI, ucK, ucRe;
	unsigned int	uiJ;
	
	ucLastChar = 161+0x20;
	usFontCharPos+=3;
	
	if(ucFontSize == 1)
	{
		usX = ((usFontCharPos/40)*16);
		usY = 312-((usFontCharPos%40)*8);
	}
	else if(ucFontSize == 2)
	{
		usX = ((usFontCharPos/20)*32);
		usY = 304-((usFontCharPos%20)*16);
	}
	else
	{
		usX = ((usFontCharPos/13)*48);
		usY = 288-((usFontCharPos%13)*24);
	}
	usFontCharPos++;
	
	for(ucI=0; ucI<(16*ucFontSize); ucI++)
	{
		vLCDSendData(LCD_INS_GRAM_HOR_AD, usX+ucI);//240

		for(uiJ=0x80000000, ucK=0; uiJ!=0x00000000; uiJ/=2, ucK+=ucFontSize)
		{
			if(suicALLAH[ucI/ucFontSize]&uiJ)
			{
				for(ucRe=0; ucRe<ucFontSize; ucRe++)
				{
					vLCDSendData(LCD_INS_GRAM_VER_AD, usY+ucK+ucRe);//320
					vLCDSendData(LCD_INS_RW_GRAM, usFontColor);
				}
			}
			else
			{
				for(ucRe=0; ucRe<ucFontSize; ucRe++)
				{
					vLCDSendData(LCD_INS_GRAM_VER_AD, usY+ucK+ucRe);//320
					vLCDSendData(LCD_INS_RW_GRAM, usFontBackground);
				}
			}
		}
	}
}