/*************************************************************************
 *
 **************************************************************************/
#include "includes.h"
#include "System/system.h"

void cTxos::vTouchGetXY()
{
	//vADC0PowerEnable();
	//get value
	PINMODE1 |= 0x00080000;
	PINMODE3 |= 0x00008000;
	//240px Y
	vADC0Enable(0);
	FIO1DIR_bit.P1_23=1;//1//lcd touch screen x+
	FIO0DIR_bit.P0_25=1;//1//lcd touch screen x- ad2
	FIO1DIR_bit.P1_24=0;//lcd touch screen y+
	FIO0DIR_bit.P0_23=0;//lcd touch screen y- ad0
	
	FIO1PIN_bit.P1_23=1;//lcd touch screen x+
	FIO0PIN_bit.P0_25=0;//lcd touch screen x- ad2
	FIO1PIN_bit.P1_24=0;//lcd touch screen y+
	FIO0PIN_bit.P0_23=0;//lcd touch screen y- ad0 read
	
	vDelayUS(30000);
	usTouchY = usADC0Read(0, 0xff);
	vADC0Disable(0);
	//320px X
	vADC0Enable(2);
	FIO1DIR_bit.P1_23=0;//lcd touch screen x+
	FIO0DIR_bit.P0_25=0;//lcd touch screen x- ad2
	FIO1DIR_bit.P1_24=1;//1//lcd touch screen y+
	FIO0DIR_bit.P0_23=1;//1//lcd touch screen y- ad0
		
	FIO1PIN_bit.P1_23=0;//lcd touch screen x+
	FIO0PIN_bit.P0_25=0;//lcd touch screen x- ad2 read
	FIO1PIN_bit.P1_24=0;//lcd touch screen y+
	FIO0PIN_bit.P0_23=1;//lcd touch screen y- ad0
		
	vDelayUS(30000);
	usTouchX = usADC0Read(2, 0xff);
	vADC0Disable(2);
	//end of get value
	PINMODE1 &= 0xfff3ffff;
	PINMODE3 &= 0xffff3fff;
	//vADC0PowerDisable();
	
	FIO1DIR_bit.P1_23=0;//lcd touch screen x+ 
	FIO0DIR_bit.P0_25=0;//lcd touch screen x- ad2
	FIO1DIR_bit.P1_24=1;//lcd touch screen y+
	FIO0DIR_bit.P0_23=1;//lcd touch screen y- ad0
  
	FIO1PIN_bit.P1_23=0;//lcd touch screen x+ 
	FIO0PIN_bit.P0_25=0;//lcd touch screen x- ad2
	FIO1PIN_bit.P1_24=0;//lcd touch screen y+
	FIO0PIN_bit.P0_23=0;//lcd touch screen y- ad0
}

void cTxos::vTouchCal()
{
	//clrscr
	vLCDClrScr();
	//Touch screen calibration
	vSetPBGCS(23, 0xffff, 0x0000, 2);
	vSPrint("Touch  screen");
	vSetPBGCS(44, 0xffff, 0x0000, 2);
	vSPrint("calibration");
	
  vTouchCal_1:
	//Note
	vSetPBGCS(400, 0xffff, 0x0000, 1);
	vSPrint("Touch the center of holes   ");
	//Hole 1 (0,0)
	vPrintPixel(0, 3,0x0000);
	vPrintPixel(1, 3,0x0000);
	vPrintPixel(2, 2,0x0000);
	vPrintPixel(3, 1,0x0000);
	vPrintPixel(3, 0,0x0000);
	//X min-Y min
	while(1)
	{
		if(FIO1PIN_bit.P1_23 == 0)
		{
			vTouchGetXY();
			usTouchXMin = usTouchX;
			usTouchYMin = usTouchY;
			
			break;
		}
		vDelayUS(300000);
	}
	vPrintPixel(0, 3,0xffff);
	vPrintPixel(1, 3,0xffff);
	vPrintPixel(2, 2,0xffff);
	vPrintPixel(3, 1,0xffff);
	vPrintPixel(3, 0,0xffff);
	vDelayUS(2000000);
	//Hole 2 (319,239)
	vPrintPixel(319, 236,0x0000);
	vPrintPixel(318, 236,0x0000);
	vPrintPixel(317, 237,0x0000);
	vPrintPixel(316, 238,0x0000);
	vPrintPixel(316, 239,0x0000);
	//X max-Y max
	while(1)
	{
		if(FIO1PIN_bit.P1_23 == 0)
		{
			vTouchGetXY();
			usTouchXMax = usTouchX;
			usTouchYMax = usTouchY;
			
			break;
		}
		vDelayUS(300000);
	}
	vPrintPixel(319, 236,0xffff);
	vPrintPixel(318, 236,0xffff);
	vPrintPixel(317, 237,0xffff);
	vPrintPixel(316, 238,0xffff);
	vPrintPixel(316, 239,0xffff);
	vDelayUS(2000000);
	//Testing
	vSetPBGCS(14, 0xffff, 0x0000, 2);
	vSPrint("  Exit");
	vSetPBGCS(134, 0xffff, 0x0000, 2);
	vSPrint(" Retry");
	//Note
	vSetPBGCS(400, 0xffff, 0x0000, 1);
	vSPrint("Touch the screen and test it.");
	
	while(1)
	{
		if(FIO2PIN_bit.P2_11 == 0)
			break;
		
		if(FIO2PIN_bit.P2_12 == 0)
			goto vTouchCal_1;
		
		if(FIO1PIN_bit.P1_23 == 0)
		{
			vTouchGetXY();
			vTouchGetPoint();
			
			if(usTouchX != 0xffff)
			{
				vPrintPixel(usTouchX-1, usTouchY-1,0x0000);
				vPrintPixel(usTouchX-1, usTouchY,  0x0000);
				vPrintPixel(usTouchX-1, usTouchY+1,0x0000);
				vPrintPixel(usTouchX,   usTouchY-1,0x0000);
				vPrintPixel(usTouchX,   usTouchY,  0x0000);
				vPrintPixel(usTouchX,   usTouchY+1,0x0000);
				vPrintPixel(usTouchX+1, usTouchY-1,0x0000);
				vPrintPixel(usTouchX+1, usTouchY,  0x0000);
				vPrintPixel(usTouchX+1, usTouchY+1,0x0000);
			}
			vDelayUS(50000);
		}
		vDelayUS(300000);
	}
}

void cTxos::vTouchGetPoint()
{
	if(usTouchX <= usTouchXMax && usTouchX >= usTouchXMin
	   && usTouchY <= usTouchYMax && usTouchY >= usTouchYMin)
	{
		usTouchX = (((usTouchX - usTouchXMin)*14)/15)/((usTouchXMax - usTouchXMin)/320);
		usTouchY = (((usTouchY - usTouchYMin)*14)/15)/((usTouchYMax - usTouchYMin)/240);
	}
	else if(usTouchX < usTouchXMin
			&& usTouchY <= usTouchYMax
			&& usTouchY >= usTouchYMin)//touch screen menu
	{
		usTouchX = 0xfff0;
		usTouchY = (usTouchY - usTouchYMin)/((usTouchYMax - usTouchYMin)/5);
	}
	else
	{
		usTouchX = 0xffff;
		usTouchY = 0xffff;
	}
}

void cTxos::vTouchGetOperation()
{
	ucOp = 0;
	
	if(usTouchX != 0xffff)
	{
		if((ucSystemMode & 0xe0) == 0x00)
		{
			if(ucSWMode == 1)//MODE
			{
				if(usTouchX == 0xfff0)//X
					ucOp = usTouchY+4;
			}
			else if(ucSWMode == 2)//Menu
			{
				if(usTouchX == 0xfff0 && usTouchY == 0)//X
					ucOp = 33;
				else if(usTouchY >= 125 && usTouchY <= 170)//Y
				{
					if(usTouchX >= 10 && usTouchX <= 55)//X
						ucOp = 25;
					else if(usTouchX >= 95 && usTouchX <= 140)//X
						ucOp = 26;
					else if(usTouchX >= 180 && usTouchX <= 225)//X
						ucOp = 27;
					else if(usTouchX >= 260 && usTouchX <= 307)//X
						ucOp = 28;
				}
				else if(usTouchY >= 188 && usTouchY <= 230)//Y
				{
					if(usTouchX >= 10 && usTouchX <= 55)//X
						ucOp = 29;
					else if(usTouchX >= 95 && usTouchX <= 140)//X
						ucOp = 30;
					else if(usTouchX >= 180 && usTouchX <= 225)//X
						ucOp = 31;
					else if(usTouchX >= 260 && usTouchX <= 307)//X
						ucOp = 32;
				}
			}
			else if(ucSWMode == 4)//Numbers
			{
				if(usTouchX == 0xfff0 && (usTouchY == 2 || usTouchY == 3))//X
					ucOp = 23;
				if(usTouchY >= 80 && usTouchY <= 115)//Y
				{
					if(usTouchX >= 60 && usTouchX <= 100)//X
						ucOp = 11;
					else if(usTouchX >= 105 && usTouchX <= 150)//X
						ucOp = 12;
					else if(usTouchX >= 155 && usTouchX <= 195)//X
						ucOp = 13;
				}
				else if(usTouchY >= 120 && usTouchY <= 150)//Y
				{
					if(usTouchX >= 60 && usTouchX <= 100)//X
						ucOp = 14;
					else if(usTouchX >= 105 && usTouchX <= 150)//X
						ucOp = 15;
					else if(usTouchX >= 155 && usTouchX <= 195)//X
						ucOp = 16;
				}
				else if(usTouchY >= 160 && usTouchY <= 190)//Y
				{
					if(usTouchX >= 60 && usTouchX <= 100)//X
						ucOp = 17;
					else if(usTouchX >= 105 && usTouchX <= 150)//X
						ucOp = 18;
					else if(usTouchX >= 155 && usTouchX <= 195)//X
						ucOp = 19;
				}
				else if(usTouchY >= 195 && usTouchY <= 225)//Y
				{
					if(usTouchX >= 60 && usTouchX <= 100)//X
						ucOp = 20;
					else if(usTouchX >= 105 && usTouchX <= 150)//X
						ucOp = 10;
					else if(usTouchX >= 155 && usTouchX <= 195)//X
						ucOp = 21;
				}
				else if(usTouchY >= 22 && usTouchY <= 50)//Y
				{
					if(usTouchX >= 204 && usTouchX <= 235)//X
						ucOp = 22;
				}
			}
		}
		else if((ucSystemMode & 0xe0) == 0x40)//gps
		{
			if(ucSWMode == 1)//MODE
				;
		}
		else if((ucSystemMode & 0xe0) == 0x60)//mpx
		{
			if(ucSWMode == 1)//MODE
			{
				if(usTouchY >= 208 && usTouchY <= 240)//Y
				{
					if(usTouchX >= 170 && usTouchX <= 201)//X
						ucOp = 35;
					else if(usTouchX >= 207 && usTouchX <= 240)//X
						ucOp = 36;
					else if(usTouchX >= 245 && usTouchX <= 277)//X
						ucOp = 37;
					else if(usTouchX >= 283 && usTouchX <= 320)//X
						ucOp = 39;
				}
			}
		}
		else if((ucSystemMode & 0xe0) == 0x20)//SMS
		{
			if(usTouchX == 0xfff0)
			{
				if(usTouchY==0)//Exit
					ucOp = 33;
				else if(ucSWMode != 1 && ucSWMode != 5)//Phone book
					ucOp = 51;
			}
			else if(ucSWMode == 1)//main menu
			{
				if(usTouchY < 64)
					ucOp = 45;//text
				else if(usTouchY < 120)
					ucOp = 46;//inbox
			}
			else if(ucSWMode == 5)//inbox
			{
				if(usTouchY < 32)
					ucOp = 49;//Next
				else if(usTouchY > 208 && usTouchY < 240)
					ucOp = 50;//delete
			}
			else
			{
				//2: FA text
				//3: EN S text
				//4: EN C text
				if(usTouchY < 32)
					ucOp = 47;//number set
				else if(usTouchY < 64)
					ucOp = 48;//char set
				else
					vTouchGetKeyboard();
			}
		}
		else if((ucSystemMode & 0xe0) == 0x80)//VLM
			;
		
		if(ucOp != 0 && (ucOp < 35 || ucOp > 39))
			vBuzzMS(150,250,0x3ff);
	}
}

void cTxos::vTouchGetKeyboard()
{
	unsigned short usI;
	
	if(usTouchY > 211)
	{
		if(usTouchX < 57)//shift
			ucOp = 52;
		else if(usTouchX < 102)//space ' '
			ucOp = 55;
		else if(usTouchX < 146)//backspace
			ucOp = 53;
		else if(usTouchX < 192)//newline \n
			ucOp = 54;
		else if(usTouchX < 213)//.
			ucOp = 56;
		else if(usTouchX < 243)//,
			ucOp = 57;
		else if(usTouchX < 273)//char
			ucOp = 58;
		else//char
			ucOp = 59;
	}
	else if(usTouchY > 182)
	{
		ucOp = 99;
		
		for(usI=50; usI<291; usI+=30)
		{
			if(usTouchX < usI)
				goto _vTouchGetKeyboard_1;
			
			ucOp++;
		}
	}
	else if(usTouchY > 152)
	{
		ucOp = 90;
		
		for(usI=50; usI<291; usI+=30)
		{
			if(usTouchX < usI)
				goto _vTouchGetKeyboard_1;
			
			ucOp++;
		}
	}
	else if(usTouchY > 122)
	{
		ucOp = 80;
		
		for(usI=34; usI<280; usI+=30)
		{
			if(usTouchX < usI)
				goto _vTouchGetKeyboard_1;
			
			ucOp++;
		}
	}
	else if(usTouchY > 92)
	{
		ucOp = 70;
		
		for(usI=34; usI<280; usI+=30)
		{
			if(usTouchX < usI)
				goto _vTouchGetKeyboard_1;
			
			ucOp++;
		}
	}
	else if(usTouchY > 62)
	{
		ucOp = 60;
		
		for(usI=34; usI<280; usI+=30)
		{
			if(usTouchX < usI)
				goto _vTouchGetKeyboard_1;
			
			ucOp++;
		}
	}
	
  _vTouchGetKeyboard_1:
	asm("NOP");
}