/*************************************************************************
 *
 **************************************************************************/
#include "includes.h"
#include "System/system.h"

void cTxos::vLoadGPSSoftware()
{
	uiMapLo = 0;
	uiMapLa = 0;
	
	if((ucSim908Mode & 0x80) == 0x80)
	{
		vLCDSendData(LCD_INS_DISP_CTRL1, 0x0133);
		if(bSim908WakeUp())
			;
	}
			
	if(!bDrawBMPFile(usFileGPSOSR)
	   || !bMapFileStatus(usFileMAPOSR))
	{
		vDetailsLineClr(12);
		vSPrint(".MAP file Error!");
		vDetailsLineClr(13);
		vSPrint("|| BG.BMP Error!");
		vDelayUS(2000000);
	}
	vDetailsLineClr(12);
	vSPrint("Getting satellite data");
	vDetailsLineClr(13);
	vSPrint("Please wait...");
	vDetailsLineClr(14);
	
	if(!bSim908SendCMD("AT+CGPSRST=0\r",2))// GPS moudle Reset 
				vSPrint("Sim908 Error!");
	
	vDelayUS(30000000);
	
	vSetPBGCS(14, 0xffff, 0x0000, 2);
	vSPrint("  Exit");
	uiLCDBLCounter = 0x00000060;
	
	ucSystemMode &= 0x1f;
	ucSystemMode |= 0x40;
	vSleep();
	
	while((ucSystemMode&0xe0) == 0x40)
	{
		vDelayUS(300000);
		vOSCheckInputs();
		
		if(uiLCDBLCounter == 200)
		{
			FIO0PIN_bit.P0_9 = 0;
			vLCDSendData(LCD_INS_DISP_CTRL1, 0x0131);//0x0133
		}
		
		if((uiLCDBLCounter&0x0000007f) == 0x00000060)
		{
			if(bSim908GetGPSStatus())
			{
				ucGPSResetMode = 1;
				vDetailsLineClr(12);
				vSPrint("Longitude: ");
				vSPrint(ucGPSLong);
				vDetailsLineClr(13);
				vSPrint("Latitude:  ");
				vSPrint(ucGPSLat);
				vDetailsLineClr(14);
				vSPrint("Your speed:");
				vSPrint(ucGPSSpeed);
				
				if(bLoadPointFromGPSMap())
					;
			}
			else
			{
				vDetailsLineClr(12);
				vSPrint("Getting satellite data");
				vDetailsLineClr(13);
				vSPrint("Please wait...");
				vDetailsLineClr(14);
			}
				
			if(ucGPSResetMode == 0)
			{
				if(!bSim908SendCMD("AT+CGPSRST=0\r",2, 6000))// GPS moudle Reset 
				{
					vDetailsLineClr(14);
					vSPrint("Sim908 Error!");
				}
				vDelayUS(5000000);
			}
			else
			{
				if(!bSim908SendCMD("AT+CGPSRST=1\r"),2, 1500)// GPS moudle Reset 
				{
					vDetailsLineClr(14);
					vSPrint("Sim908 Error!");
				}
			}
			
			if(bSim908CheckMode())
				;
		}
		uiLCDBLCounter++;
	};
	vNormalOperation();
}
