/*************************************************************************
 *
 **************************************************************************/
#include "includes.h"
#include "System/system.h"

bool cTxos::bLoadPointFromGPSMap()
{
	vLocationAToUI();
	
	if(uiIntLongitude <= uiMapLongEnd
	   && uiIntLongitude >= uiMapLongStart
	   && uiIntLatitude <= uiMapLatEnd
	   && uiIntLatitude >= uiMapLatStart)
	{
		uiCurrentLoationPxLo =  (uiIntLongitude-uiMapLongStart)
								/((uiMapLongEnd-uiMapLongStart)/(uiMapPxLo*uiMapNuOLo));
		
		uiCurrentLoationPxLa =  (uiIntLatitude-uiMapLatStart)
								/((uiMapLatEnd-uiMapLatStart)/(uiMapPxLa*uiMapNuOLa));
		
		if(uiMapLo != ((uiCurrentLoationPxLo/uiMapPxLo)+1)
		   || uiMapLa != ((uiCurrentLoationPxLa/uiMapPxLa)+1))
			if(!bMapDraw())
				return 0;
		
		vMapPrintCurrentLacation();
		
		return 1;
	}
	
	return 0;
}

bool cTxos::bMapFileStatus(unsigned short usCalNumber)
{
	vHighSpeedOperation();
	
	if(!bOpenFile(usCalNumber))
	{
		vSleep();
		
		return 0;
	}
	
	if(!bReadFile())
	{
		vSleep();
		
		return 0;
	}
	
	if(ucFileBlockData[0]=='M'
	   && ucFileBlockData[1]=='A'
	   && ucFileBlockData[2]=='P')
	{
		uiMapPxLo 		= ucFileBlockData[4]|(ucFileBlockData[5]<<8);
		uiMapPxLa 		= ucFileBlockData[6]|(ucFileBlockData[7]<<8);
		
		uiMapNuOLo 		= ucFileBlockData[8]|(ucFileBlockData[9]<<8);
		uiMapNuOLa 		= ucFileBlockData[10]|(ucFileBlockData[11]<<8);
		
		uiMapLongStart	= ucFileBlockData[12]
						  |(ucFileBlockData[13]<<8)
						  |(ucFileBlockData[14]<<16)
						  |(ucFileBlockData[15]<<24);
		uiMapLongEnd	= ucFileBlockData[16]
						  |(ucFileBlockData[17]<<8)
						  |(ucFileBlockData[18]<<16)
						  |(ucFileBlockData[19]<<24);
		
		uiMapLatStart	= ucFileBlockData[20]
						  |(ucFileBlockData[21]<<8)
						  |(ucFileBlockData[22]<<16)
						  |(ucFileBlockData[23]<<24);
		uiMapLatEnd		= ucFileBlockData[24]
						  |(ucFileBlockData[25]<<8)
						  |(ucFileBlockData[26]<<16)
						  |(ucFileBlockData[27]<<24);
		
		vSleep();
		
		return 1;
	}
	vSleep();
	
	return 0;
}

void cTxos::vLocationAToUI()
{
	//Longitude: 1000.000000-9959.999999
	if(ucGPSLong[0] == '-')
		uiIntLongitude = 0;
	else
	{
		if(ucGPSLong[4] == '.')//DDMM.mmmmmm
		{
			//MM
			uiIntLongitude  = (ucGPSLong[2] - 0x30)*100000;
			uiIntLongitude += (ucGPSLong[3] - 0x30)*10000;
			//mmm
			uiIntLongitude += (ucGPSLong[5] - 0x30)*1000;
			uiIntLongitude += (ucGPSLong[6] - 0x30)*100;
			uiIntLongitude += (ucGPSLong[7] - 0x30)*10;
			//MM.mmm --> iiiiii
			uiIntLongitude  = ((uiIntLongitude*100)/60);
			//DDiiiiii (DDMM.mmmmmm --> DD.iiiiii)
			uiIntLongitude += (ucGPSLong[0] - 0x30)*10000000;
			uiIntLongitude += (ucGPSLong[1] - 0x30)*1000000;
		}
		else
			uiIntLongitude = 0;
	}
	//Latitude: 1000.000000-9000.000000
	if(ucGPSLat[0] == '-')
		uiIntLatitude = 0;
	else
	{
		if(ucGPSLat[4] == '.')//DDMM.mmmmmm
		{
			//MM
			uiIntLatitude  = (ucGPSLat[2] - 0x30)*100000;
			uiIntLatitude += (ucGPSLat[3] - 0x30)*10000;
			//mmm
			uiIntLatitude += (ucGPSLat[5] - 0x30)*1000;
			uiIntLatitude += (ucGPSLat[6] - 0x30)*100;
			uiIntLatitude += (ucGPSLat[7] - 0x30)*10;
			//MM.mmm --> iiiiii
			uiIntLatitude  = ((uiIntLatitude*100)/60);
			//DDiiiiii (DDMM.mmmmmm --> DD.iiiiii)
			uiIntLatitude += (ucGPSLat[0] - 0x30)*10000000;
			uiIntLatitude += (ucGPSLat[1] - 0x30)*1000000;
		}
		else
			uiIntLatitude = 0;
	}
}

bool cTxos::bMapDraw()
{
	unsigned char ucY;
	unsigned short usI;
	unsigned int uiX;
	
	//frame
	for(ucY=185; ucY>0; ucY--)
		vPrintPixel(181,ucY-1,0x000f);
	for(ucY=185; ucY>0; ucY--)
		vPrintPixel(182,ucY-1,0x000f);
	for(ucY=185; ucY>0; ucY--)
		vPrintPixel(183,ucY-1,0x000f);
	for(ucY=185; ucY>0; ucY--)
		vPrintPixel(184,ucY-1,0x000f);

	for(ucY=0; ucY<184;ucY++)
		vPrintPixel(ucY,181,0x000f);
	for(ucY=0; ucY<184;ucY++)
		vPrintPixel(ucY,182,0x000f);
	for(ucY=0; ucY<184;ucY++)
		vPrintPixel(ucY,183,0x000f);
	for(ucY=0; ucY<184;ucY++)
		vPrintPixel(ucY,184,0x000f);
	//find map addr
	uiMapLo = (uiCurrentLoationPxLo/uiMapPxLo)+1;
	uiMapLa = (uiCurrentLoationPxLa/uiMapPxLa)+1;
	
	//Find map address.
	uiX = uiMapPxLo*uiMapPxLa;
	
	if((uiX&0x000001ff) != 0)
		uiX = ((uiX&0xfffffe00) + 0x200)>>9;
	else
		uiX = uiX>>9;
	
	uiX = (((uiMapLa-1)*uiX)+(((uiMapLo-1)*uiX)*uiMapNuOLa)+1);
	vReadFileGoToAddr(uiX);
	//drawing map
	if(!bReadFile())
		return 0;
	
	usI=0;
	
	for(ucY=180; ucY>0; )
	{
		ucY--;
		
		for(uiX=0; uiX<180;uiX++)
		{			
			if(usI == 512)
			{
				if(!bReadFile())
					return 0;
				
				usI = 0;
			}
			vPrintPixel(uiX,ucY,( ((ucFileBlockData[usI]&0x80)>>7)<<11)//Red
								|(((ucFileBlockData[usI]&0x80)>>7)<<12)//7-5
								|(((ucFileBlockData[usI]&0xe0)>>5)<<13)//15-11

								|(((ucFileBlockData[usI]&0x10)>>4)<<5 )//Green
								|(((ucFileBlockData[usI]&0x10)>>4)<<6 )//4-2
								|(((ucFileBlockData[usI]&0x10)>>4)<<7 )//10-5
								|(((ucFileBlockData[usI]&0x1c)>>2)<<8 )//
									
								|(((ucFileBlockData[usI]&0x02)>>1)<<0 )//Blue
								|(((ucFileBlockData[usI]&0x02)>>1)<<1 )//1-0
								|(((ucFileBlockData[usI]&0x02)>>1)<<2 )//4-0
								|(((ucFileBlockData[usI]&0x03)>>0)<<3));//
			usI++;
		}
	}
	
	return 1;
}

void cTxos::vMapPrintCurrentLacation()
{
	//find Location px
	uiCurrentLoationPxLo = uiCurrentLoationPxLo%uiMapPxLo;
	uiCurrentLoationPxLa = uiMapPxLa-(uiCurrentLoationPxLa%uiMapPxLa);
	//print Location
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa+0,0x0000);
	
	vPrintPixel(uiCurrentLoationPxLo+1,uiCurrentLoationPxLa+0,0xffff);
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa+1,0xffff);
	vPrintPixel(uiCurrentLoationPxLo-1,uiCurrentLoationPxLa+0,0xffff);
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa-1,0xffff);
	
	vPrintPixel(uiCurrentLoationPxLo+2,uiCurrentLoationPxLa+0,0xffff);
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa+2,0xffff);
	vPrintPixel(uiCurrentLoationPxLo-2,uiCurrentLoationPxLa+0,0xffff);
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa-2,0xffff);
	
	vPrintPixel(uiCurrentLoationPxLo+1,uiCurrentLoationPxLa+1,0xffff);
	vPrintPixel(uiCurrentLoationPxLo-1,uiCurrentLoationPxLa-1,0xffff);
	vPrintPixel(uiCurrentLoationPxLo-1,uiCurrentLoationPxLa+1,0xffff);
	vPrintPixel(uiCurrentLoationPxLo+1,uiCurrentLoationPxLa-1,0xffff);
	//**************************************************************//
	vPrintPixel(uiCurrentLoationPxLo+3,uiCurrentLoationPxLa+0,0x0000);
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa+3,0x0000);
	vPrintPixel(uiCurrentLoationPxLo-3,uiCurrentLoationPxLa+0,0x0000);
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa-3,0x0000);
	
	vPrintPixel(uiCurrentLoationPxLo+1,uiCurrentLoationPxLa+2,0x0000);
	vPrintPixel(uiCurrentLoationPxLo-1,uiCurrentLoationPxLa-2,0x0000);
	vPrintPixel(uiCurrentLoationPxLo-1,uiCurrentLoationPxLa+2,0x0000);
	vPrintPixel(uiCurrentLoationPxLo+1,uiCurrentLoationPxLa-2,0x0000);
	
	vPrintPixel(uiCurrentLoationPxLo+2,uiCurrentLoationPxLa+1,0x0000);
	vPrintPixel(uiCurrentLoationPxLo-2,uiCurrentLoationPxLa-1,0x0000);
	vPrintPixel(uiCurrentLoationPxLo-2,uiCurrentLoationPxLa+1,0x0000);
	vPrintPixel(uiCurrentLoationPxLo+2,uiCurrentLoationPxLa-1,0x0000);
	//**************************************************************//
	vPrintPixel(uiCurrentLoationPxLo+4,uiCurrentLoationPxLa+0,0xf800);
	vPrintPixel(uiCurrentLoationPxLo+5,uiCurrentLoationPxLa+0,0xf800);
	vPrintPixel(uiCurrentLoationPxLo+6,uiCurrentLoationPxLa+0,0xf800);
	
	vPrintPixel(uiCurrentLoationPxLo-4,uiCurrentLoationPxLa+0,0xf800);
	vPrintPixel(uiCurrentLoationPxLo-5,uiCurrentLoationPxLa+0,0xf800);
	vPrintPixel(uiCurrentLoationPxLo-6,uiCurrentLoationPxLa+0,0xf800);
	
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa+4,0xf800);
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa+5,0xf800);
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa+6,0xf800);
	
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa-4,0xf800);
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa-5,0xf800);
	vPrintPixel(uiCurrentLoationPxLo+0,uiCurrentLoationPxLa-6,0xf800);
}
