/*************************************************************************
 *
 **************************************************************************/
#include "includes.h"
#include "System/system.h"

void cTxos::vMPXSoftwareRun()
{	
	unsigned int	uiX;
	
	vDetailsLineClr(0);
	vSPrint("initializing MPX software.");
	vDetailsLineClr(1);
	vSPrint("Please wait...");
	
	if(bSim908GsmOff())
		;
	if(bSim908GpsOff())
		;
	if((ucSim908Mode & 0x80) == 0x00)
		if(bSim908Sleep())
			;
	
	if(bDrawBMPFile(usFileMPXOSR) 
	   && bOpenDir(usFileMPXFolderOSR))
	{		
		FIO3DIR_bit.P3_26 = 0;//Speaker
		bMPXPlay = false;
		ucSystemMode &= 0x1f;
		ucSystemMode |= 0x60;
		ucSWMode = 1;
		vDACEnable();
		vSleep();
		
	  vMPXSoftwareRun_1:
		DACR_bit.VALUE = 0;
		uiMPXCounter = 0;
		
		vSetPBGCS(520, 0xffff, 0x0000, 1);
		vSPrint("               ");
		vSetPBGCS(560, 0xffff, 0x0000, 1);
		vSPrint("               ");
		
		if(bMPXPlay)
		{
			vSetPBGCS(480, 0xffff, 0x0000, 1);
			vSPrint(ucFileName);
			vSPrint(" finished.");
			
			vSetPBGCS(520, 0xffff, 0x0000, 1);
			vSPrint("Playing next...");
			
			vDelayUS(2000000);
		}
		
		if(bReadMPXFile())
		{
			uiLCDBLCounter = 0;
			
			vSetPBGCS(480, 0xffff, 0x0000, 1);
			vSPrint("MPX File Found:   ");
			
			vSetPBGCS(520, 0xffff, 0x0000, 1);
			vSPrint(ucFileName);
			vSPrint("        ");
			
			vDelayUS(1000000);
			
			while((ucSystemMode&0xe0)==0x60)
			{
				if(bMPXPlay)
				{
					if(uiMPXCounter == 0)
					{
						vSetPBGCS(560, 0xffff, 0x0000, 1);
						vSPrint("is Playing...   ");
						
						for(uiMPXCounter=0; uiMPXCounter<240;uiMPXCounter++)
							vPrintPixel(uiMPXCounter,179,0x0000);
						for(uiMPXCounter=0; uiMPXCounter<240;uiMPXCounter++)
							vPrintPixel(uiMPXCounter,180,0x0000);
						
						for(uiMPXCounter=0; uiMPXCounter<240;uiMPXCounter++)
							vPrintPixel(uiMPXCounter,181,0xfff0);
						for(uiMPXCounter=0; uiMPXCounter<240;uiMPXCounter++)
							vPrintPixel(uiMPXCounter,182,0xfff0);
						
						for(uiMPXCounter=0; uiMPXCounter<240;uiMPXCounter++)
							vPrintPixel(uiMPXCounter,183,0x0000);
						for(uiMPXCounter=0; uiMPXCounter<240;uiMPXCounter++)
							vPrintPixel(uiMPXCounter,184,0x0000);
						
						vPrintPixel(0,182,0x0000);
						vPrintPixel(0,181,0x0000);
						
						vPrintPixel(1,182,0x0000);
						vPrintPixel(1,181,0x0000);
						
						vPrintPixel(239,182,0x0000);
						vPrintPixel(239,181,0x0000);
						
						vPrintPixel(238,182,0x0000);
						vPrintPixel(238,181,0x0000);
						
						uiMPXCounter = 0;
					}
					vMPXPlayBuffer();
					uiMPXCounter++;
					
					if(uiLCDBLCounter%32 == 0)
					{
						vOSCheckInputs();
						
						if(bMPXPlay == false && uiMPXCounter == 1210)
						{
							bMPXPlay = true;
							
							goto vMPXSoftwareRun_1;
						}
						
						if(uiLCDBLCounter == 512)
						{
							FIO0PIN_bit.P0_9 = 0;
							vLCDSendData(LCD_INS_DISP_CTRL1, 0x0131);//0x0133
						}
					}
					else if(uiX != ((uiMPXCounter/uiMPXCount)))
					{
						uiX = (uiMPXCounter/uiMPXCount);
								
						if(uiX < 236)
						{
							vPrintPixel(uiX+2, 182, 0x001f);
							vPrintPixel(uiX+2, 181, 0x001f);
						}
					}
					
					if(!bReadFile())
						goto vMPXSoftwareRun_1;
				}
				else
				{
					vDelayUS(300000);
					vOSCheckInputs();
					if(uiLCDBLCounter == 128)
					{
						FIO0PIN_bit.P0_9 = 0;
						vLCDSendData(LCD_INS_DISP_CTRL1, 0x0131);//0x0133
					}
					
					if(bMPXPlay == true && uiMPXCounter == 1210)
					{
						bMPXPlay = false;
						
						goto vMPXSoftwareRun_1;
					}
				}
				uiLCDBLCounter++;
			}
		}
		else
		{
			vDetailsLineClr(12);
			vSPrint("MPX file not found OR");
			vDetailsLineClr(13);
			vSPrint("Memory Error!!!");
			vDetailsLineClr(14);
		}
	}
	else
	{
		ucSystemMode &= 0x1c;
		ucSystemMode |= 0x02;
		
		vDetailsLineClr(12);
		vSPrint("Error in:");
		vDetailsLineClr(13);
		vSPrint("initializing MPX software.");
	}
	vDetailsLineClr(14);
	vSPrint("Cancelling...   ");
	
	vDACDisable();
	
	vDelayUS(3000000);
}

void cTxos::vMPXPlayBuffer()
{
	unsigned short  usI;
	
	for(usI=0; usI<512; usI+=2)
	{
		DACR_bit.VALUE = (ucFileBlockData[usI]|(ucFileBlockData[usI+1]<<8))>>6;//10 bits
		vDelayUS(116);
	}
}
