/*************************************************************************
 *
 **************************************************************************/
#include "includes.h"
#include "System/system.h"
#include "LCD/font.h"

void cTxos::vSMSSoftwareRun()
{
	vSetPBGCS(0, 0xffff, 0x0000, 1);
	vSPrint("SMS Loading... ");
	
	if(!bSim908SendCMD("ATE0\r",2,1000))
		vSPrint("-1");
	vSPrint(ucDataRam[0]);
	
	if(!bSim908SendCMD("AT+CSMP=17,167,2,25\r",2, 1000))
		vSPrint("0");
	vSPrint(ucDataRam[0]);
	
	if(!bSim908SendCMD("AT+CSCS=\"HEX\"\r",2, 1000))
		vSPrint("1");
	vSPrint(ucDataRam[0]);
	
	if(!bSim908SendCMD("AT+CNMI=0,1,2,2\r",2, 1000))
		vSPrint("2");
	vSPrint(ucDataRam[0]);
	
	if(!bSim908SendCMD("AT+CMGF=1\r",2, 1000))
		vSPrint("3");
	vSPrint(ucDataRam[0]);
	
	//clrscr
	vLCDClrScr();
	
	ucSystemMode &= 0x1f;
	ucSystemMode |= 0x20;
	ucSWMode = 1;
	
	vSetPBGCS(0, 0x001f, 0xffff, 2);
	vSPrint("SMS                 ");
	vSetPBGCS(20, 0xF79E, 0x0000, 2);
	vSPrint("New Message         ");
	vSetPBGCS(40, 0xE77C, 0x0000, 2);
	vSPrint("InBox               ");
	
	if(bNewSMS == 1)
	{
		vSetPBGCS(52, 0xE77C, 0xf800, 2);
		vSPrint("New");
	}
}

void cTxos::vSMSSoftwareTextBox()
{
	//clrscr
	vLCDClrScr();
	ucSWMode = 3;//EN_S
	bNCSelect = 1;
	ucSMSPrintCharPos = 20;
	ucSMSPrintCharNumber = 0;
	ucSMSPrintNumberPos = 0;
	ucPhoneBookN = 0;
	
	if(!bDrawSMSBMPFile())
		;
	
	ucPhoneNumber[0] = 0;
	ucErrMsg[0] = 0;
	ucSystemLog[0] = 0;
	
	vSetPBGCS(0, 0xffff, 0xC618, 2);
	vSPrint(" Number             ");
	vSetPBGCS(1, 0xffff, 0xC618, 2);
	vSPrint("");
	vSetPBGCS(20, 0xE73C, 0xC618, 2);
	vSPrint(" Text               ");
	vSetPBGCS(21, 0xE73C, 0xC618, 2);
	vSPrint("");
	bRTL = 0;
}

void cTxos::vSMSSoftwareInBox()
{
	ucSWMode = 5;//inbox
	ucSystemLog[8] = '1';//Index_1
	vSMSSoftwareLoadMessage();
}

void cTxos::vSMSSoftwareLoadMessage()
{
	//clrscr: 
	vLCDClrScr();
	
	if(bSim908ReadSMS()==1)
	{
		vSetPBGCS(0, 0x001f, 0xffff, 2);
		vSPrint("                  >>");
		vSetPBGCS(120, 0xf800, 0x0000, 2);
		vSPrint("       Delete       ");
		//Print Number
		vSetPBGCS(0, 0x001f, 0xffff, 1);
		vSPrint(ucDataRam[0]);
		//Print name
		if(ucDataRam[1][0] > 127)
			vSetPBGCS(4, 0x001f, 0xffff, 1);
		
		vSPrint(ucDataRam[1]);
		//Print date
		vSetPBGCS(40, 0x001f, 0xffff, 1);
		vSPrint(ucDataRam[2]);
		//print text
		if(strlen(ucDataRam[4]) < 100)
			vSetPBGCS(20, 0xffff, 0x0000, 2);
		else
			vSetPBGCS(80, 0xffff, 0x0000, 1);
	
		vSPrint(ucDataRam[4]);
	}
	else
	{
		vSetPBGCS(0, 0xffff, 0x0000, 3);
		vSPrint("No Message!  ");
		vSPrint(" !");
	}
}

unsigned char cTxos::ucITOHexFAConvert(unsigned char ucCh)
{
	if(ucCh <= 0xd6)
		return (ucCh - 0xa0);
	
	if(ucCh <= 0xdb)
		return (ucCh - 0xa1);
	
	switch(ucCh)
	{
	  case 0xDD:
		return 0x41;
	  case 0xDE:
		return 0x42;
	  case 0xDF:
		return 0x43;
	  case 0xE1:
		return 0x44;
	  case 0xE3:
		return 0x45;
	  case 0xE4:
		return 0x46;
	  case 0xE5:
		return 0x47;
	  case 0xE6:
		return 0x48;
	  case 0xEC:
		return 0x49;
	  case 0xED:
		return 0x4A;
	  case 0x81:
		return 0x7E;
	  case 0x8D:
		return 0x86;
	  case 0x8E:
		return 0x98;
	  case 0x98:
		return 0xA9;
	}

	return 0xAF; //''
}

unsigned char cTxos::ucHexTOIFAConvert(unsigned char ucCh)
{
	if(ucCh <= 0x36)
		return (ucCh + 0xa0);
	
	if(ucCh <= 0x3a)
		return (ucCh + 0xa1);
	
	switch(ucCh)
	{
	  case 0x41:
		return 0xDD;
	  case 0x42:
		return 0xDE;
	  case 0x43:
		return 0xDF;
	  case 0x44:
		return 0xE1;
	  case 0x45:
		return 0xE3;
	  case 0x46:
		return 0xE4;
	  case 0x47:
		return 0xE5;
	  case 0x48:
		return 0xE6;
	  case 0x49:
		return 0xEC;
	  case 0x4A:
		return 0xED;
	  case 0x7E:
		return 0x81;
	  case 0x86:
		return 0x8D;
	  case 0x98:
		return 0x8E;
	  case 0xA9:
		return 0x98;
	  case 0xCC:
		return '';
	  case 0xBE:
		return '';
	  case 0xC1:
		return '';
	  case 0xD0:
		return '';
	}

	return ''; //0xAF
}

unsigned char cTxos::ucHexToI(unsigned int uiHex)
{
	unsigned char ucCh[4];
	
	ucCh[0] = uiHex>>24;
	ucCh[1] = uiHex>>16;
	ucCh[2] = uiHex>>8;
	ucCh[3] = uiHex>>0;
	
	if(ucCh[0]>='a')
		ucCh[0] = (ucCh[0] - 0x57);
	else if(ucCh[0]>'9')
		ucCh[0] = (ucCh[0] - 0x37);
	else
		ucCh[0] = (ucCh[0] - 0x30);
	
	if(ucCh[1]>='a')
		ucCh[1] = (ucCh[1] - 0x57);
	else if(ucCh[1]>'9')
		ucCh[1] = (ucCh[1] - 0x37);
	else
		ucCh[1] = (ucCh[1] - 0x30);
	
	ucCh[0] = (ucCh[0]|(ucCh[1]<<4));
	
	if(ucCh[2] == '6')
		return ucHexTOIFAConvert(ucCh[0]);
	
	return ucCh[0];
}

unsigned int cTxos::uiITOHex(unsigned char ucCh)
{
	if(ucCh>127)
	{
		ucCh = ucITOHexFAConvert(ucCh);

		return (0x30360000|((succITOHex[(ucCh>>4)]<<8)|(succITOHex[ucCh&0x0f]>>0)));
	}

	return (0x30300000|((succITOHex[(ucCh>>4)]<<8)|(succITOHex[ucCh&0x0f]>>0)));
}
