/*************************************************************************
 *
 **************************************************************************/
#include "includes.h"
#include "System/system.h"
#include "LCD/font.h"

void cTxos::vOperation()
{
	switch(ucOp)
	{
	  case 0:
		break;
	  case 1://SW1
		if((ucSystemMode & 0xe0) == 0x00)
		{
			if(ucSWMode == 1)
				;
			if(ucSWMode == 2)
				;
			if(ucSWMode == 4)
			{
				vSetPBGCS(123, 0xffff, 0x0000, 1);
				vSPrint("Calling...     ");
				bSim908Call(ucPhoneNumber);
				
				if(bSim908CheckResponce("OK")
				   || bSim908CheckResponce("CONNECT"))
				{
					vSetPBGCS(123, 0xffff, 0x0000, 1);
					vSPrint("Successful call");
					bCalling = true;
				}
				else if(bSim908CheckResponce("BUSY"))
				{
					vSetPBGCS(123, 0xffff, 0x0000, 1);
					vSPrint("Busy!!!        ");
					//ucSWMode = 1;
				}
				else
				{
					vSetPBGCS(123, 0xffff, 0x0000, 1);
					vSPrint("NO Dialtone    ");
					//ucSWMode = 1;
				}
			}
			if(ucSWMode == 5)
				FIO3DIR_bit.P3_26^=1;//Speaker
			if(ucSWMode == 6)
			{
				if(bSim908AnswerCall())
					;
				
				vDetailsLineClr(13);
				vSPrint("Talk");
				
				bCalling = true;
				FIO0PIN_bit.P0_9 = 1;//LCD light
				bRingInit = 0;
			}
		}
		else if((ucSystemMode & 0xe0) == 0x40)//gps
		{
			if(ucSWMode == 1)
				;
		}
		else if((ucSystemMode & 0xe0) == 0x60)//mpx
		{
			if(ucSWMode == 1)
				;
		}
		else if((ucSystemMode & 0xe0) == 0x20)//SMS
		{
			if(ucSWMode == 2 || ucSWMode == 3 || ucSWMode == 4)
			{
				if(bSim908SendSMS() == 1)
				{
					vSetPBGCS(0, 0xffff, 0x0000, 2);
					vSPrint("Message sent.      ");
					
					vSetPBGCS(20, 0xE73C, 0x0000, 2);
					vSPrint("  .  ");
				}
				else
				{
					vSetPBGCS(0, 0xffff, 0x0000, 2);
					vSPrint("Error. ReTry?      ");
					
					vSetPBGCS(20, 0xE73C, 0x0000, 2);
					vSPrint(".  ?   ");
				}
			}
		}
		break;
	  case 2://SW2
		if((ucSystemMode & 0xe0) == 0x00)
		{
			if(ucSWMode == 1)
				;
			if(ucSWMode == 2)
				;
			if(ucSWMode == 3)
			{
				if(bSim908HangUpCall())
					;
					
				ucSWMode = 4;
				bCalling = false;
				
				vSetPBGCS(123, 0xffff, 0x0000, 1);
				vSPrint("Hanged Up      ");
			}
			else if(ucSWMode == 4)
			{
				if(bSim908HangUpCall())
					;
					
				ucSWMode = 1;
				bCalling = false;
				
				if(!bDrawBMPFile(usFileBGOSR))
					vOSError();
				
				vDetailsLineClr(12);
				vSPrint("*Status:*");
			}
			if(ucSWMode == 5)//Calling-HangUp
			{
				if(bSim908HangUpCall())
					;
					
				ucSWMode = 1;
				bCalling = false;
			}
			if(ucSWMode == 6)//IncomingCall-HangUp
			{
				if(bSim908HangUpCall())
					;
					
				ucSWMode = 1;
				bCalling = false;
			}
		}
		else if((ucSystemMode & 0xe0) == 0x40)//gps
		{
			if(ucSWMode == 1)
			{
				vSetPBGCS(14, 0xffff, 0x0000, 2);
				vSPrint("      ");
			
				if(bSim908GpsOff())
					;
				
				ucSWMode = 1;
				ucSystemMode &= 0x1c;
				ucSystemMode |= 0x02;
			}
		}
		else if((ucSystemMode & 0xe0) == 0x60)//mpx
		{
			if(ucSWMode == 1)
			{
				vSetPBGCS(16, 0xffff, 0x0000, 2);
				vSPrint("    ");
			
				ucSWMode = 1;
				ucSystemMode &= 0x1c;
				ucSystemMode |= 0x02;
			}
		}
		break;
	  case 3://Reserved
		break;
	  case 4://MENU
		if(bDrawBMPFile(usFileMENUOSR))
			ucSWMode = 2;
		else
			vOSError();
		break;
	  case 5://SMS
		vSMSSoftwareRun();
		break;
	  case 6://Phone book
		goto vOperation_3;
	  case 7://Call
	  vOperation_3:
		if(bDrawBMPFile(usFileNOSR))
		{
			ucSWMode = 4;
			ucPhoneBookN = 0;
		  vOperation_2:
			vSetPBGCS(123, 0xffff, 0x0000, 1);
			vSPrint("               ");
			vSetPBGCS(83, 0xffff, 0x0000, 1);
			vSPrint("               ");
			vSetPBGCS(83, 0xffff, 0x0000, 1);
			ucPhoneNumber[0] = '\0';
			
			if(ucOp == 3 || ucOp == 23 || ucOp == 26)//Phone book
			{
				if(ucPhoneBook[0][0] != 0)
				{
					vSPrint(ucPhoneBookNumber[ucPhoneBookN]);
					vSetPBGCS(123, 0xffff, 0x0000, 1);
					vSPrint(ucPhoneBook[ucPhoneBookN]);
					strcpy(ucPhoneNumber, ucPhoneBookNumber[ucPhoneBookN]);
					
					if(ucPhoneBook[ucPhoneBookN+1][0] != '\0')
						ucPhoneBookN++;
					else
						ucPhoneBookN = 0;
				}
				else
				{
					vSetPBGCS(123, 0xffff, 0x0000, 1);
					vSPrint("No number!     ");
				}
			}
		}
		else
			vOSError();
		break;
	  case 8://MPX
		vMPXSoftwareRun();
		break;
	  case 9:
		break;
	  case 10:
		strcat(ucPhoneNumber, "0");
		vSetPBGCS(82+strlen(ucPhoneNumber), 0xffff, 0x0000, 1);
		vPrint('0');
		break;
	  case 11:
		strcat(ucPhoneNumber, "1");
		vSetPBGCS(82+strlen(ucPhoneNumber), 0xffff, 0x0000, 1);
		vPrint('1');
		break;
	  case 12:
		strcat(ucPhoneNumber, "2");
		vSetPBGCS(82+strlen(ucPhoneNumber), 0xffff, 0x0000, 1);
		vPrint('2');
		break;
	  case 13:
		strcat(ucPhoneNumber, "3");
		vSetPBGCS(82+strlen(ucPhoneNumber), 0xffff, 0x0000, 1);
		vPrint('3');
		break;
	  case 14:
		strcat(ucPhoneNumber, "4");
		vSetPBGCS(82+strlen(ucPhoneNumber), 0xffff, 0x0000, 1);
		vPrint('4');
		break;
	  case 15:
		strcat(ucPhoneNumber, "5");
		vSetPBGCS(82+strlen(ucPhoneNumber), 0xffff, 0x0000, 1);
		vPrint('5');
		break;
	  case 16:
		strcat(ucPhoneNumber, "6");
		vSetPBGCS(82+strlen(ucPhoneNumber), 0xffff, 0x0000, 1);
		vPrint('6');
		break;
	  case 17:
		strcat(ucPhoneNumber, "7");
		vSetPBGCS(82+strlen(ucPhoneNumber), 0xffff, 0x0000, 1);
		vPrint('7');
		break;
	  case 18:
		strcat(ucPhoneNumber, "8");
		vSetPBGCS(82+strlen(ucPhoneNumber), 0xffff, 0x0000, 1);
		vPrint('8');
		break;
	  case 19:
		strcat(ucPhoneNumber, "9");
		vSetPBGCS(82+strlen(ucPhoneNumber), 0xffff, 0x0000, 1);
		vPrint('9');
		break;
	  case 20:
		strcat(ucPhoneNumber, "*");
		vSetPBGCS(82+strlen(ucPhoneNumber), 0xffff, 0x0000, 1);
		vPrint('*');
		break;
	  case 21:
		strcat(ucPhoneNumber, "#");
		vSetPBGCS(82+strlen(ucPhoneNumber), 0xffff, 0x0000, 1);
		vPrint('#');
		break;
	  case 22:
		ucSWMode = 4;
		ucPhoneNumber[0] = '\0';
		vSetPBGCS(123, 0xffff, 0x0000, 1);
		vSPrint("               ");
		vSetPBGCS(83, 0xffff, 0x0000, 1);
		vSPrint("               ");
		vSetPBGCS(83, 0xffff, 0x0000, 1);
		break;
	  case 23:
		goto vOperation_2;
	  case 25://Call
		goto vOperation_3;
	  case 26://Call list
		vCallListRun();
		break;
	  case 27://SMS
		vSMSSoftwareRun();
		break;
	  case 28://MPX
		vMPXSoftwareRun();
		break;
	  case 29://GPS
		if((ucSystemMode&0xe0) != 0x40)
		{
			ucSystemMode &= 0x1f;
			ucSystemMode |= 0x40;
				
			vDetailsLineClr(0);
			vSPrint("Initializing GPS");
			vDetailsLineClr(1);
			vSPrint("Please Wait...");
			ucSWMode = 1;
			vDelayUS(1000000);
					
			if(bSim908GpsOn())
				vLoadGPSSoftware();
			else
			{
				if(bSim908GpsOff())
					;
					
				//ucSWMode = 1;
				ucSystemMode &= 0x1c;
				ucSystemMode |= 0x02;
					
				vDetailsLineClr(0);
				vSPrint("GPS Initialize Error");
				vDetailsLineClr(1);
				vDelayUS(1000000);
			}
		}
		
		break;
	  case 30://Volt meter, light meter
		vVLMSoftwareRun();
		break;
	  case 31:
		break;
	  case 32:
		break;
	  case 33:
		ucSWMode = 1;
		ucSystemMode &= 0x1f;
		
		if(!bDrawBMPFile(usFileBGOSR))
			vOSError();
		
		vDetailsLineClr(12);
		vSPrint("*Status:*");
		
		break;
	  case 34:
		break;
	  case 35://play
		if(bMPXPlay == 1)
		{
			vSleep();
			bMPXPlay = 0;
		}
		else
		{
			vHighSpeedOperation();
			bMPXPlay = 1;
		}
		
		break;
	  case 36://forward
		if(bMPXPlay && usFileCalusters[ucFileLastCal]!=0)
		{
			ucFileLastCal |= 0x3f;
			ucFileLastBlockOfCal = 0;
		}
		break;
	  case 37://next
		uiMPXCounter = 1210;
		bMPXPlay ^= 1;
		break;
	  case 38:
		break;
	  case 39://load
		FIO3DIR_bit.P3_26^=1;//Speaker
		FIO3PIN_bit.P3_26 = 0;//Speaker
		break;
	  case 45://SMS
		vSMSSoftwareTextBox();
		break;
	  case 46:
		vSMSSoftwareInBox();
		break;
	  case 47://number
		bNCSelect = 0;
		break;
	  case 48://char
		bNCSelect = 1;
		break;
	  case 49://Next SMS
		vSMSSoftwareLoadMessage();
		break;
	  case 50://Delete
		ucSystemLog[0] = 'A';
		ucSystemLog[1] = 'T';
		ucSystemLog[2] = '+';
		ucSystemLog[3] = 'C';
		ucSystemLog[4] = 'M';
		ucSystemLog[5] = 'G';
		ucSystemLog[6] = 'D';
		ucSystemLog[7] = '=';
		
		if(ucSystemLog[8] == '1')
			ucSystemLog[8] = '9';
		else
			ucSystemLog[8]--;
		
		ucSystemLog[9] = '\r';
		ucSystemLog[10] = 0;
	
		if(!bSim908SendCMD(ucSystemLog,2,1000))
			vSPrint("Error!");
	
		if(ucSystemLog[8] == '9')
			ucSystemLog[8] = '1';
		else
			ucSystemLog[8]++;
		
		vSMSSoftwareLoadMessage();
	
		break;
	  case 51://Phone book
		vSetPBGCS(0, 0xffff, 0x0000, 1);
		vSPrint("                                        ");
		vSPrint("                                        ");
		ucPhoneNumber[0] = '\0';

		if(ucPhoneBook[0][0] != 0)
		{
			vSetPBGCS(0, 0xffff, 0x0000, 1);
			vSPrint(ucPhoneBookNumber[ucPhoneBookN]);
			vSetPBGCS(40, 0xffff, 0x0000, 1);
			vSPrint(ucPhoneBook[ucPhoneBookN]);
			strcpy(ucPhoneNumber, ucPhoneBookNumber[ucPhoneBookN]);
			ucSMSPrintNumberPos = strlen(ucPhoneNumber);

			if(ucPhoneBook[ucPhoneBookN+1][0] != '\0')
				ucPhoneBookN++;
			else
				ucPhoneBookN = 0;
		}
		else
		{
			vSetPBGCS(40, 0xffff, 0x0000, 1);
			vSPrint("No number!     ");
		}
		
		break;
	  case 52:
		if(ucSWMode == 4)
		{
			ucSWMode = 2;

			if(!bDrawSMSBMPFile())
				;
		}
		else
		{
			ucSWMode++;

			if(!bDrawSMSBMPFile())
				;
		}
		
		break;
	  case 53://backspace
		if(bNCSelect == 0 && ucSMSPrintNumberPos > 0)//Number
		{
			ucSMSPrintNumberPos--;
			ucPhoneNumber[ucSMSPrintNumberPos] = 0;
			vSetPBGCS(ucSMSPrintNumberPos, 0xffff, 0x0000, 2);
			vPrint(' ');
		}
		else if(ucSMSPrintCharNumber > 0)
		{
			ucSMSPrintCharNumber--;
			
			if(ucSMSPrintCharPos == 20)
			{
				ucSMSPrintCharPos = 39;
				vSetPBGCS(ucSMSPrintCharPos, 0xE73C, 0x0000, 2);
				vPrint(' ');
			}
			else
			{
				ucSMSPrintCharPos--;
				vSetPBGCS(ucSMSPrintCharPos, 0xE73C, 0x0000, 2);
				vPrint(' ');
			}
			ucSystemLog[ucSMSPrintCharNumber] = 0;
		}
		
		break;
	}
	
	if(ucOp >= 54 && ucOp <= 107)
	{
		if(bNCSelect == 0 && ucSMSPrintNumberPos < 19)//Number
		{
			bRTL = 0;
			ucPhoneNumber[ucSMSPrintNumberPos] = succKeyBoardCh[ucOp-54][ucSWMode-2];
			
			if(ucPhoneNumber[ucSMSPrintNumberPos] != '\n')
			{
				vSetPBGCS(ucSMSPrintNumberPos, 0xffff, 0x0000, 2);
				vPrint(ucPhoneNumber[ucSMSPrintNumberPos]);
				ucSMSPrintNumberPos++;
			}
		}
		else if(ucSMSPrintCharNumber < 98)
		{
			if(ucSWMode == 2)
				bRTL = 1;
			
			ucSystemLog[ucSMSPrintCharNumber] = succKeyBoardCh[ucOp-54][ucSWMode-2];
			
			if(ucSystemLog[ucSMSPrintCharNumber]>127)
			{
				if(ucSMSPrintCharPos>20 && ucSystemLog[ucSMSPrintCharNumber-1]>127)
				{
					vSetPBGCS(ucSMSPrintCharPos-1, 0xE73C, 0x0000, 2);
					vPrint(ucSystemUTFPersianConvert(ucSystemLog[ucSMSPrintCharNumber-1], ''));
				}
				vSetPBGCS(ucSMSPrintCharPos, 0xE73C, 0x0000, 2);
				vPrint(ucSystemUTFPersianConvert(ucSystemLog[ucSMSPrintCharNumber], ' '));
			}
			else if(ucSystemLog[ucSMSPrintCharNumber] == '\n')
			{
				ucSMSPrintCharPos = 19;
				vSetPBGCS(20, 0xE73C, 0x0000, 2);
				vPrint(' ');
			}
			else
			{
				vSetPBGCS(ucSMSPrintCharPos, 0xE73C, 0x0000, 2);
				vPrint(ucSystemLog[ucSMSPrintCharNumber]);
			}
			
			if(ucSMSPrintCharPos < 36)
			{
				vPrint(' ');
				vPrint(' ');
				vPrint(' ');
				vPrint(' ');
			}
			ucSMSPrintCharNumber++;
			ucSMSPrintCharPos++;
			
			if(ucSMSPrintCharPos == 40)
				ucSMSPrintCharPos = 20;
		}
	}
}
