/*************************************************************************
 *
 **************************************************************************/
#include "includes.h"
#include "System/system.h"

void cTxos::vOSLoad()
{	
	bCalling = false;
	ucSim908Mode = 0x00;
	
	while(1)
	{
		if(bCalling)
			vOSCalling();
		
		if(!bCalling)
			vOSMainMenuLoad();
		
		uiLCDBLCounter++;

		if(ucSWMode == 6)
		{
			FIO0PIN_bit.P0_9 ^=0;//LCD light
		
			if(uiLCDBLCounter%8 == 0)
			{
				FIO0PIN_bit.P0_9 =1;//LCD light
				if(!bSim908GetCallingStatus())
				{
					ucSWMode = 1;
					uiLCDBLCounter = 0;
					bCalling = false;
				}
				else if(ucDataRam[1][0] == '6')
				{
					ucSWMode = 1;
					uiLCDBLCounter = 0;
					bCalling = false;
				}
				else
				{
					vDetailsLineClr(14);
					vSPrint(ucDataRam[0]);
					
					if(!bCallStatus)
					{
						bCallStatus = 1;
						strcpy(ucIncomingCalls[ucIncomingCallN], ucDataRam[0]);
					
						if(ucIncomingCallN < 5)
						{
							ucIncomingCallN++;
							ucIncomingCalls[ucIncomingCallN][0] = 0;
						}
						else
							ucIncomingCallN = 0;
					}
				}
			}
		}
		vDelayUS(50000);
		vOSCheckUART();
		vDelayUS(50000);
		vOSCheckUART();
		vDelayUS(50000);
		vOSCheckUART();
		vDelayUS(50000);
		vOSCheckUART();
		vDelayUS(100000);
		vOSCheckUART();
		vOSCheckInputs();
	}
}

void cTxos::vOSCalling()
{
	if(ucSWMode != 5 && ucSWMode != 3)
	{
		if(ucSWMode != 4)
		{
			vSetPBGCS(14, 0xffff, 0x0000, 2);
			vSPrint("HangUp");
		
			vSetPBGCS(134, 0xffff, 0x0000, 2);
			vSPrint("  Load");
			ucSWMode = 5;
		}
		else
			ucSWMode = 3;
	}
	else if(uiLCDBLCounter%16 == 0)
	{		
		if(!bSim908GetCallingStatus())
		{
			if(ucSWMode == 5)
				ucSWMode = 1;
			else
			{
				ucSWMode = 4;
				vSetPBGCS(123, 0xffff, 0x0000, 1);
				vSPrint("No answer      ");
			}
			uiLCDBLCounter = 0;
			bCalling = false;
		}
		else if(ucDataRam[1][0] == '6')
		{
			if(ucSWMode == 5)
				ucSWMode = 1;
			else
			{
				ucSWMode = 4;
				vSetPBGCS(123, 0xffff, 0x0000, 1);
				vSPrint("No answer      ");
			}
			uiLCDBLCounter = 0;
			bCalling = false;
		}
	}
}

bool cTxos::bOSFileInit()
{
	unsigned char ucI, ucJ;
	unsigned short usK = 0xf880;//f8cc
	
	ucPhoneBook[0][0] = 0;
	ucPhoneBook[2][0] = 0;
	ucPhoneBook[3][0] = 0;
	ucPhoneBook[4][0] = 0;
	ucPhoneBook[5][0] = 0;
	ucPhoneBook[6][0] = 0;
	ucPhoneBook[7][0] = 0;
	ucPhoneBook[8][0] = 0;
	ucPhoneBook[9][0] = 0;
	
	strcpy(ucErrMsg,"bOsFileInit");
	//Drawing background
	if(bSDMMCInit())//ucErrMsg in sdmmc.c
	{
		if(bFileInit())//ucErrMsg in fat.c
		{
			ucI = 0;
			strcpy(ucErrMsg,"/");
			
			while(ucI<16)
			{
				ucI++;
				vReadDir();
				
				if(ucFileName[0] == 'R'
				   && ucFileName[1] == 'O'
				   && ucFileName[2] == 'O'
				   && ucFileName[3] == 'T'
				   && (usK&0x00ff)!=0x00ff)
				{
					strcpy(ucErrMsg,"/ROOT/");
					usFileROOTFolderOSR = usFileOSR;
					
					if(bOpenDir(usFileOSR))
					{
						ucJ = 0;
						while(ucJ<16 && (usK & 0xff) != 0xff)
						{
							ucJ++;
							vReadDir();
							
							if(ucFileName[0] == 'B'
							   && ucFileName[1] == 'G'
							   && (usK & 0x01) == 0)//ROOT/BG.bmp
							{
								usFileBGOSR = usFileOSR;
								usK |= 0x01;
							}
							else if(ucFileName[0] == 'M'
									&& ucFileName[1] == 'E'
									&& ucFileName[2] == 'N'
									&& ucFileName[3] == 'U'
									&& (usK & 0x02) == 0)//ROOT/MENU.bmp
							{
								usFileMENUOSR = usFileOSR;
								usK |= 0x02;
							}
							else if(ucFileName[0] == 'S'
									&& ucFileName[1] == 'F'
									&& (usK & 0x04) == 0)//ROOT/SF.bmp
							{
								usFileSMSOSR[0] = usFileOSR;
								usK |= 0x04;
							}
							else if(ucFileName[0] == 'S'
									&& ucFileName[1] == 'S'
									&& ucFileName[2] == 'E'
									&& (usK & 0x08) == 0)//ROOT/SSE.bmp
							{
								usFileSMSOSR[1] = usFileOSR;
								usK |= 0x08;
							}
							else if(ucFileName[0] == 'S'
									&& ucFileName[1] == 'C'
									&& ucFileName[2] == 'E'
									&& (usK & 0x40) == 0)//ROOT/SCE.bmp
							{
								usFileSMSOSR[2] = usFileOSR;
								usK |= 0x40;
							}
							else if(ucFileName[0] == 'N'
									&& (usK & 0x10) == 0)//ROOT/N.bmp
							{
								usFileNOSR = usFileOSR;
								usK |= 0x10;
							}
							else if(ucFileName[0] == 'P'
									&& ucFileName[1] == 'H'
									&& ucFileName[2] == 'B'
									&& (usK & 0x20) == 0)//ROOT/PHB.txt
							{
								if(!bGetNuFromPhBook(usFileOSR))
								{
									strcpy(ucErrMsg,"/root/PHB.txt");
					
									return 0;
								}
								usFilePHBOSR = usFileOSR;
								usK |= 0x20;
							}
						}
					}
					bOpenDir(0);
				}
				else if(ucFileName[0] == 'G'
						&& ucFileName[1] == 'P'
						&& ucFileName[2] == 'S'
						&& (usK&0x0300)!=0x0300)
				{
					strcpy(ucErrMsg,"/GPS/");
					usFileGPSFolderOSR = usFileOSR;
					
					if(bOpenDir(usFileOSR))
					{
						ucJ = 0;
						while(ucJ<16 && (usK&0x0300)!=0x0300)
						{
							ucJ++;
							vReadDir();
							
							if(ucFileName[0] == 'G'
							   && ucFileName[1] == 'P'
							   && ucFileName[2] == 'S'
							   && (usK & 0x0100) == 0)//GPS/GPS.bmp
							{
								usFileGPSOSR = usFileOSR;
								usK |= 0x0100;
							}
							else if(ucFileName[0] == 'M'
									&& ucFileName[1] == 'A'
									&& ucFileName[2] == 'P'
									&& (usK & 0x0200) == 0)//GPS/MAP.map
							{
								usFileMAPOSR = usFileOSR;
								usK |= 0x0200;
							}
						}
					}
					bOpenDir(0);
				}
				else if(ucFileName[0] == 'M'
						&& ucFileName[1] == 'P'
						&& ucFileName[2] == 'X'
						&& (usK&0x0400)!=0x0400)
				{
					strcpy(ucErrMsg,"/MPX/");
					usFileMPXFolderOSR = usFileOSR;
					
					if(bOpenDir(usFileOSR))
					{
						ucJ = 0;
						while(ucJ<16 && (usK&0x0400)!=0x0400)
						{
							ucJ++;
							vReadDir();
							
							if(ucFileName[0] == 'M'
							   && ucFileName[1] == 'P'
							   && ucFileName[2] == 'X'
							   && (usK & 0x0400) == 0)//MPX/MPX.bmp
							{
								usFileMPXOSR = usFileOSR;
								usK |= 0x0400;
							}
						}
					}
					bOpenDir(0);
				}
				
				if(usK == 0xffff)
					return 1;
			}
		}
	}
	
	return 0;
}

void cTxos::vOSCheckInputs()
{
	if(FIO2PIN_bit.P2_12 == 0)//51 - SW1 - p2.12 - Down - Green
	{
		uiLCDBLCounter = 0;
		
		if(FIO0PIN_bit.P0_9 == 0)
		{
			if(((ucSystemMode & 0xe0) != 0x60) && ((ucSystemMode & 0xe0) != 0x40))
				vNormalOperation();
			
			vLCDSendData(LCD_INS_DISP_CTRL1, 0x0133);
			FIO0PIN_bit.P0_9 =1;//LCD light
		}
		else
		{
			ucOp = 1;
			vOperation();
		}
		
		while(!FIO2PIN_bit.P2_12)
			;
		
		vDelayUS(500000);
	}
	else if(FIO2PIN_bit.P2_11 == 0)//52 - SW2 - P2.11 - Up - Red
	{
		uiLCDBLCounter = 0;
		
		if(FIO0PIN_bit.P0_9 == 0)
		{
			if(((ucSystemMode & 0xe0) != 0x60) && ((ucSystemMode & 0xe0) != 0x40))
				vNormalOperation();
			
			vLCDSendData(LCD_INS_DISP_CTRL1, 0x0133);
			FIO0PIN_bit.P0_9 =1;//LCD light
		}
		else
		{
			if(FIO2PIN_bit.P2_11 == 0)
			{
				vDelayUS(1000000);
				
				if(FIO2PIN_bit.P2_11 == 0)
				{
					vDelayUS(1000000);
					
					if(FIO2PIN_bit.P2_11 == 0)//Shut down!
					{
						ucSystemMode &= 0x1c;//0xfc
						
						goto vOSCheckKeys_2;
					}
				}
			}
			ucOp = 2;
			vOperation();
		}
		while(!FIO2PIN_bit.P2_11)
			;
		vDelayUS(500000);
		
	  vOSCheckKeys_2:
		asm("NOP");
	}
	else if(FIO2PIN_bit.P2_10 == 0)//53 - SW3 - P2.10 - Center - White
	{
		uiLCDBLCounter = 0;
			
		if(FIO0PIN_bit.P0_9 == 0)
		{
			if(((ucSystemMode & 0xe0) != 0x60) && ((ucSystemMode & 0xe0) != 0x40))
				vNormalOperation();
			
			vLCDSendData(LCD_INS_DISP_CTRL1, 0x0133);
			FIO0PIN_bit.P0_9 =1;//LCD light
		}
		else
		{
			ucOp = 3;
			vOperation();
		}		
		
		while(!FIO2PIN_bit.P2_10)
			;
		vDelayUS(500000);
	}
	else if(FIO1PIN_bit.P1_23 == 0
			&& FIO0PIN_bit.P0_9 == 1)//Touch screen
	{
		vTouchGetXY();
		vTouchGetPoint();
		vTouchGetOperation();
		
		if(ucOp != 0)
		{
			vOperation();
			uiLCDBLCounter = 1;
			vDelayUS(500000);
		}
	}
}

void cTxos::vOSCheckUART()
{
	if(U1LSR & 0x01)
	{
		vWaitForUartResponseMS(1,500);
		
		if(bSim908CheckResponce("NO ANSWER"))
		{
			ucSWMode = 1;
			uiLCDBLCounter = 0;
			bCalling = false;
		}
		else if(ucSWMode != 6 && bSim908CheckResponce("RING"))
		{
			if((ucSim908Mode & 0x80) == 0x80)
			{
				vNormalOperation();
				vLCDSendData(LCD_INS_DISP_CTRL1, 0x0133);
				
				if(bSim908WakeUp())
					;
			}
			
			if(!bRingInit)
			{
				strcpy(ucIncomingCalls[ucIncomingCallN], "NO Number");
				bRingInit = 1;
			}
			vSetPBGCS(14, 0xffff, 0x0000, 2);
			vSPrint("HangUp");
		
			vSetPBGCS(134, 0xffff, 0x0000, 2);
			vSPrint("Answer");
			
			vDetailsLineClr(13);
			vSPrint("Incoming call");
			FIO0PIN_bit.P0_9 =1;//LCD light
			
			ucSWMode = 6;
		}
		else if(ucSim908CheckResponceCMD("+CMTI:")!=10)
		{
			bNewSMS = 1;
			FIO0PIN_bit.P0_9 ^= 1;
			FIO3DIR_bit.P3_26=1;//Speaker
			if((ucSystemMode & 0xe0) == 0x00)
				vBuzzMS(1000,500,0x3ff);
			FIO3DIR_bit.P3_26=0;//Speaker
			FIO0PIN_bit.P0_9 ^= 1;
		}
	}
}
	
void cTxos::vOSMainMenuLoad()
{
//0-1:System status
	if((ucSystemMode & 0x03) == 0x00)//00:off (Put sim908 on AT+CFUN=0)
	{
		//Shut down!
		//clrscr
		vLCDClrScr();
		
		vSetPBGCS(26, 0xffff, 0x00ff, 3);
		vSPrint("Shutting down");
	
		vDelayUS(1000);
		
		if(bSim908CheckMode() == 1)
		{
			//vSetPBGCS(70, 0xffff, 0x0000, 1);
			//vSPrint("iaroo*");
			U1FCR = 0x07;
			vSim908OnOff();
			ucSim908Mode = 0;
		//vDelayUS(5000000);			
			vWaitForUartResponseMS(1,2500);
		}
		//Moudle turning off
		vUartDisable(1);
		vDelayUS(1000000);
		
		ucSystemMode = 0x01;
		FIO0PIN_bit.P0_9 =0;//LCD light
		FIO1PIN_bit.P1_22=0;//lcd RESET#
		vPowerDown();
		
		while(1)
		{
			if(FIO2PIN_bit.P2_11 == 0)
			{
				vDelayUS(100000);
				
				if(FIO2PIN_bit.P2_11 == 0)
				{
					vNormalOperation();
					FIO1PIN_bit.P1_22=1;//lcd RESET#
					vLCDInit();
					
					break;
				}
			}
			
			vDelayUS(100000);
		}
		//Turning on
	}
	if((ucSystemMode & 0x03) == 0x01)//01:on (Load BG, PhB, main menu & welcome)
	{	
		//clrscr
		vLCDClrScr();
		
		FIO0PIN_bit.P0_9 =1;//LCD light
		
		vSetPBGCS(0, 0xffff, 0x0000, 1);
		vSPrint("Starting...");
		
		vSetPBGCS(29, 0xffff, 0x00ff, 3);
		vSPrint("* Txos *");
		
		vSetPBGCS(367, 0xffff, 0x0000, 1);
		vSPrint("The Xerxes Operating System");
		
		vDelayUS(1000000);
		
		vSetPBGCS(16, 0xffff, 0x07c0, 1);
		vPrint('W');
		vDelayUS(500000);
		vPrint('e');
		vDelayUS(500000);
		vPrint('l');
		vDelayUS(500000);
		vPrint('c');
		vDelayUS(500000);
		vPrint('o');
		vDelayUS(500000);
		vPrint('m');
		vDelayUS(500000);
		vPrint('e');
		vDelayUS(500000);
		
		FIO3DIR_bit.P3_26=1;//Speaker
		vBuzzMS(500, 250, 0x3ff);
		FIO3DIR_bit.P3_26=0;//Speaker
		
		vDelayUS(1000000);
		
		if(!bOSFileInit())//Init SDMMC & File-Background load
			vOSError();
		
		ucSystemMode &= 0xfc;
		ucSystemMode |= 0x02;
	}
	if((ucSystemMode & 0x03) == 0x02)//10:Reset (Load BG & main menu agin)
	{
		bCalling = false;
		FIO0PIN_bit.P0_9 =1;//LCD light
		FIO3DIR_bit.P3_26=0;//Speaker
		ucSWMode = 0;
		//Drawing
		if(!bDrawBMPFile(usFileBGOSR))
			vOSError();
		
		vDetailsLineClr(12);
		vSPrint("*Status:*");
		
		vDetailsLineClr(13);
		vSPrint("Initializing...");
		
		vDelayUS(500000);
		
		uiLCDBLCounter = 0;
		ucSystemMode &= 0x1c;
		ucSystemMode |= 0x03;
		ucSWMode = 1;
	}
	if((ucSystemMode & 0x03) == 0x03)//11:normal
		;
//2:Reserved
	if((ucSystemMode & 0x04) == 0x00)//0:
		;
	if((ucSystemMode & 0x04) == 0x04)//1:
		;
//3-4:Battery
	if((ucSystemMode & 0x18) == 0x00)//00:
		;
	if((ucSystemMode & 0x18) == 0x08)//01:
		;
	if((ucSystemMode & 0x18) == 0x10)//10:
		;
	if((ucSystemMode & 0x18) == 0x18)//11:
		;
//5-7:Softwares
	if((ucSystemMode & 0xe0) == 0x00
	   && ucSWMode != 5 && ucSWMode != 6
	   &&(uiLCDBLCounter&0x0000003f) == 0x00000000)//000:GSM mode/desktop
	{
		FIO3DIR_bit.P3_26 = 0;//Speaker
		
		if(uiLCDBLCounter == 0x00000080)
		{
			FIO0PIN_bit.P0_9 = 0;
			vSleep();
		}
		
		if(FIO0PIN_bit.P0_9 == 1)
		{
			if((ucSim908Mode & 0x80) == 0x80)
			{
				vNormalOperation();
				vLCDSendData(LCD_INS_DISP_CTRL1, 0x0133);
				
				if(bSim908WakeUp())
					;
			}

			if(!bSim908CheckMode())
			{
				vDelayUS(500000);
			
				if(bSim908GsmOn())//result in ucSim908Mode
					;

				vDelayUS(500000);
			}
		
			if((ucSim908Mode & 0x03) == 0x01)
				if(bSim908SetCall())//result in ucSim908Mode
					;
			
			if(ucSWMode == 1)
			{
				if(ucSim908Mode == 0)//not running
				{
					vDetailsLineClr(13);
					vSPrint("Sim908 disconnected!");
					vDetailsLineClr(14);
				}
				else if(bSim908GetRegStatus())
				{
					vDetailsLineClr(13);
					vSPrint("(:Simcard registered:)");
					vDetailsLineClr(14);
					vSPrint(ucDataRam[0]);
				}
				else
				{
					vDetailsLineClr(13);
					vSPrint("Simcard NOT registered!");
					vDetailsLineClr(14);
				}
				vSetPBGCS(14, 0xffff, 0x0000, 2);
				vSPrint("      ");
				vSetPBGCS(134, 0xffff, 0x0000, 2);
				vSPrint("      ");
				
				vDetailsLineClr(0);
				vSPrint("  MVT.0t1002");
				
				vDetailsLineClr(1);
				vSPrint("00000.14a003");
				
				vSetPBGCS(63, 0xffff, 0x0000, 1);
				vSPrint("");
				
				vDetailsLineClr(2);
				vSPrint("Xerxes-co.com");
				
				if(ucSim908Mode != 0)
					vSim908ShowTimeBATAnt();
				
				vDetailsLineClr(12);
				vSPrint("*Status:*");
				
				bCallStatus = 0;
					
				if(bRingInit == 1)
				{
					bNewCall = 1;
					bRingInit = 0;
				}
				
				if(bNewCall)
				{
					vSetPBGCS(0, 0xf800, 0xffff, 1);
					vSPrint("C");
				}
				
				if(bNewSMS)
				{
					vSetPBGCS(1, 0xf800, 0x0000, 1);
					vSPrint("S");
				}
			}
			else if(ucSWMode == 4)
			{
				if(ucSim908Mode == 0)//not running
				{
					vSetPBGCS(43, 0xffff, 0x0000, 1);
					vSPrint("Sim908 error!     ");
				}
				else if(bSim908GetRegStatus())
				{
					vSetPBGCS(43, 0xffff, 0x0000, 1);
					vSPrint("*Sim registered.  ");
				}
				else
				{
					vSetPBGCS(43, 0xffff, 0x0000, 1);
					vSPrint("Sim NOT registered");
				}
			}
		}
		else if((ucSim908Mode & 0x80) == 0x00)
		{
			vLCDSendData(LCD_INS_DISP_CTRL1, 0x0130);//0x0133
			
			if(bSim908Sleep())
				;
		}
	}
	if((ucSystemMode & 0xe0) == 0x20)//001:SMS mode
		;
	if((ucSystemMode & 0xe0) == 0x40)//010:GPS mode
		;
	if((ucSystemMode & 0xe0) == 0x60)//011:MPX mode
		;
	if((ucSystemMode & 0xe0) == 0x80)//100:VLM mode
		;
	if((ucSystemMode & 0xe0) == 0xa0)//101:Reserved
		;
	if((ucSystemMode & 0xe0) == 0xc0)//110:Reserved
		;
	if((ucSystemMode & 0xe0) == 0xe0)//111:Reserved
		;
}

void cTxos::vOSError()
{
	vDetailsLineClr(13);
	vSPrint("OS Error!");
	vDetailsLineClr(14);
	vSPrint(ucErrMsg);
	
	vDelayUS(5000000);
}

void cTxos::vOSStart()
{
	//clrscr
	vLCDClrScr();
	
	//In the name of The God
	vSetPBGCS(10, 0xffff, 0x0000, 1);
	vSPrint("   ");
	//In the name of The God
	vSetPBGCS(47, 0xffff, 0x0000, 1);
	vSPrint("    ");
	//In the name of The God
	vSetPBGCS(89, 0xffff, 0x0000, 1);
	vSPrint("In the name of The God");
	//Note
	vSetPBGCS(120, 0xffff, 0x0000, 1);
	vSPrint("MVT.0t1000-00000.14a003 (Txos)\rProgrammer: MVT\rDirector: Xerxes Company\rProvider: Xerxes Corporation");
	vSPrint("\rMade for: MVT.6b5000-00xxx.136000\r          MVT.495000-000xx.133000\r(Designer: MVT\r Director: Xerxes Company\r Provider: Xerxes Corporation");
	vSPrint("\rNote: Press and hold SW1 (Down key) for calibration of touch screen.");
	//LCD light
	FIO0PIN_bit.P0_9 =1;
	vDelayUS(10000000);
	ucSystemMode = 0x01;
}

void cTxos::vCallListRun()
{
	//clrscr
	vLCDClrScr();
	bNewCall = 0;
	vSetPBGCS(0, 0x001f, 0xffff, 2);
	vSPrint("Call list           ");
	vSetPBGCS(20, 0xF79E, 0x0000, 2);
	vSPrint(ucIncomingCalls[0]);
	vSetPBGCS(40, 0xC618, 0xffff, 2);
	vSPrint(ucIncomingCalls[1]);
	vSetPBGCS(60, 0xF79E, 0x0000, 2);
	vSPrint(ucIncomingCalls[2]);
	vSetPBGCS(80, 0xC618, 0xffff, 2);
	vSPrint(ucIncomingCalls[3]);
	vSetPBGCS(100, 0xF79E, 0x0000, 2);
	vSPrint(ucIncomingCalls[4]);
	vSetPBGCS(120, 0xC618, 0xffff, 2);
	vSPrint(ucIncomingCalls[5]);
}