/***************************************************************************
 **\t=="    " (4 Space)
 **
 **	Master include file
 **
 **	Used with ARM IAR C/C++ Compiler
 **
 **	(c) Copyright IAR Systems 2007
 **
 **	$Revision: 33177 $
 **
 ***************************************************************************/

#ifndef __INCLUDES_H
#define __INCLUDES_H

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdbool.h>
#include <limits.h>
#include <intrinsics.h>
#include <assert.h>
#include <nxp/iolpc1768.h>

#include "System/interrupts.h"

//Configurations:
//**********************************************
//*SD-MMC
#define GO_IDLE_STATE 					0x40
#define SEND_OP_COND 					0x41
#define SET_BLOCK_LEN 					0x50
#define READ_BLOCK 						0x51
#define WRITE_BLOCK 					0x58
//**********************************************
//*Dealays
#define SDMMCCLOCKDELAYUS 				0
#define LCDCLOCKDELAYUS 				0
//**********************************************
//*LCD
#define LCD_SIZE_X 						240
#define LCD_SIZE_Y 						320
#define LCD_VAL_ENTRY_MOD				0x0030
#define LCD_INS_GRAM_ADX				LCD_INS_GRAM_HOR_AD
#define LCD_INS_GRAM_ADY				LCD_INS_GRAM_VER_AD
#define LCD_INS_START_ADX				LCD_INS_HOR_START_AD
#define LCD_INS_END_ADX					LCD_INS_HOR_END_AD
#define LCD_INS_START_ADY				LCD_INS_VER_START_AD
#define LCD_INS_END_ADY					LCD_INS_VER_END_AD

#define LCD_INS_START_OSC				0x00 //data read at this instruction should be 0x0789 --> use for test connection
#define LCD_INS_DRIV_OUT_CTRL			0x01
#define LCD_INS_DRIV_WAV_CTRL			0x02
#define LCD_INS_ENTRY_MOD				0x03
#define LCD_INS_RESIZE_CTRL				0x04
#define LCD_INS_DISP_CTRL1				0x07
#define LCD_INS_DISP_CTRL2				0x08
#define LCD_INS_DISP_CTRL3				0x09
#define LCD_INS_DISP_CTRL4				0x0A
#define LCD_INS_RGB_DISP_IF_CTRL1		0x0C
#define LCD_INS_FRM_MARKER_POS			0x0D
#define LCD_INS_RGB_DISP_IF_CTRL2		0x0F
#define LCD_INS_POW_CTRL1				0x10
#define LCD_INS_POW_CTRL2				0x11
#define LCD_INS_POW_CTRL3				0x12
#define LCD_INS_POW_CTRL4				0x13
#define LCD_INS_GRAM_HOR_AD				0x20
#define LCD_INS_GRAM_VER_AD				0x21
#define LCD_INS_RW_GRAM					0x22
#define LCD_INS_POW_CTRL7				0x29
#define LCD_INS_FRM_RATE_COL_CTRL		0x2B
#define LCD_INS_GAMMA_CTRL1				0x30
#define LCD_INS_GAMMA_CTRL2				0x31
#define LCD_INS_GAMMA_CTRL3				0x32
#define LCD_INS_GAMMA_CTRL4				0x35
#define LCD_INS_GAMMA_CTRL5				0x36
#define LCD_INS_GAMMA_CTRL6				0x37
#define LCD_INS_GAMMA_CTRL7				0x38
#define LCD_INS_GAMMA_CTRL8				0x39
#define LCD_INS_GAMMA_CTRL9				0x3C
#define LCD_INS_GAMMA_CTRL10			0x3D
#define LCD_INS_HOR_START_AD			0x50
#define LCD_INS_HOR_END_AD				0x51
#define LCD_INS_VER_START_AD			0x52
#define LCD_INS_VER_END_AD				0x53
#define LCD_INS_GATE_SCAN_CTRL1			0x60
#define LCD_INS_GATE_SCAN_CTRL2			0x61
#define LCD_INS_GATE_SCAN_CTRL3			0x6A
#define LCD_INS_PART_IMG1_DISP_POS		0x80
#define LCD_INS_PART_IMG1_START_AD		0x81
#define LCD_INS_PART_IMG1_END_AD		0x82
#define LCD_INS_PART_IMG2_DISP_POS  	0x83
#define LCD_INS_PART_IMG2_START_AD  	0x84
#define LCD_INS_PART_IMG2_END_AD		0x85
#define LCD_INS_PANEL_IF_CTRL1			0x90
#define LCD_INS_PANEL_IF_CTRL2			0x92
#define LCD_INS_PANEL_IF_CTRL3			0x93
#define LCD_INS_PANEL_IF_CTRL4			0x95
#define LCD_INS_PANEL_IF_CTRL5			0x97
#define LCD_INS_PANEL_IF_CTRL6			0x98

#endif  // __INCLUDES_H
