/*************************************************************************
 *
TXOS
T   X      O         S
The Xerxes Operating System
Provided for MVT.6b5000 & MVT.495000

.
X_e_r_x_e_s_
 LABORATORY 
  MVT.0t1000 
00xxx.14a003

Last revisions:
00xxx.136000 
00xxx.13b001
00xxx.141002 

Programmer: MVT 
Director: Xerxes company 
Provider: Xerxes corporation. 

 *************************************************************************/

#include "includes.h"
#include "System/system.h"

cTxos cTxos1;

/*************************************************************************
 * 53 - SW3 - P2.10 - Center
 *************************************************************************/
void EINT0_IRQHandler (void)
{
	;
}
/*************************************************************************
 * 52 - SW2 - P2.11 - Up - Call/Answer
 *************************************************************************/
void EINT1_IRQHandler (void)
{
	;
}
/*************************************************************************
 * 51 - SW1 - p2.12 - Down - GPS/Reject
 *************************************************************************/
void EINT2_IRQHandler (void)
{
	;
}
/*************************************************************************
 *
 *************************************************************************/
void EINT3_IRQHandler (void)
{
	;
}
/*************************************************************************
 *
 *************************************************************************/
void UART1_IRQHandler (void)
{
	;
}
/*************************************************************************
 *
 *************************************************************************/
void TMR0_IRQHandler (void)
{
	;
}
/*************************************************************************
 * Function Name: main
 * Parameters: none
 *
 * Return: none
 *
 * Description: The Xerxes Operation System (TXOS v. 0.0.0.1)
 *
 *************************************************************************/
int main(void)
{
	//Default touch values
	cTxos1.usTouchXMax = 0xE44;
	cTxos1.usTouchYMax = 0xCD8;
	cTxos1.usTouchXMin = 0x263;
	cTxos1.usTouchYMin = 0x292;
	
	//Intializing...
	cTxos1.ucIncomingCalls[0][0] = 0;
	cTxos1.ucIncomingCalls[1][0] = 0;
	cTxos1.ucIncomingCalls[2][0] = 0;
	cTxos1.ucIncomingCalls[3][0] = 0;
	cTxos1.ucIncomingCalls[4][0] = 0;
	cTxos1.ucIncomingCalls[5][0] = 0;
	cTxos1.ucIncomingCallN = 0;
	cTxos1.bNewCall = 0;
	cTxos1.bNewSMS = 0;
	cTxos1.bCallStatus = 0;
	cTxos1.bRingInit = 0;
	
	PCON = 0x00000F1C;
	PCONP = 0x00009012; //GPIO&TIMER0 are enable
	cTxos1.ucSystemPowerMode = 0x02;
	
	// 1. Disconnect PLL
	PLL0CON_bit.PLLC = 0;
	PLL0FEED = 0xAA;
	PLL0FEED = 0x55;
	
	// 2. Disable PLL
	PLL0CON_bit.PLLE = 0;
	PLL0FEED = 0xAA;
	PLL0FEED = 0x55;
	
	// 3. Set PLL settings 216 MHz
	PLL0CFG_bit.MSEL = 27-1;//27-1;
	PLL0FEED = 0xAA;
	PLL0FEED = 0x55;
	PLL0CFG_bit.NSEL = 1-1;//1-1;
	PLL0FEED = 0xAA;
	PLL0FEED = 0x55;
	
	cTxos1.vDelayUS(10000);
	
	cTxos1.vGpioInit();
	FIO0PIN_bit.P0_9 =0;//LCD light
	FIO1PIN_bit.P1_18=1;//Green LED
	
	cTxos1.vDelayUS(1000);
	
	cTxos1.vPowerDown();
	cTxos1.vDelayUS(1000);
	
	FIO1PIN_bit.P1_18=0;//Green LED
	cTxos1.vDelayUS(1000);
	FIO1PIN_bit.P1_22=0;//lcd RESET#
	
	while(1)
	{
		if(FIO2PIN_bit.P2_11 == 0)//51 - SW1 - p2.12 - Down - HangUp/Exit/on/off
		{
			cTxos1.vDelayUS(100000);
			
			if(FIO2PIN_bit.P2_11 == 0)
			{
				cTxos1.vNormalOperation();
				FIO1PIN_bit.P1_22=1;//lcd RESET#
				cTxos1.vLCDInit();
	
				break;
			}
		}
		cTxos1.vDelayUS(100000);
	}
	cTxos1.vOSStart();
	
	if(FIO2PIN_bit.P2_12 == 0)
		cTxos1.vTouchCal();
	
	cTxos1.vOSLoad();
}
